angular.module('kronoapp', ['ngIOS9UIWebViewPatch', 'ngCordova', 'ngAnimate', 'restangular', 'ionic', 'underscore', 'firebase', 'i18n', 'ngStorage', 'angularMoment', 'angular-loading-bar', 'ngVisibility', 'utils.services', 'utils.directives', 'utils.push_v5', 'kronoapp.config', 'kronoapp.analytics', 'kronoapp.device.services', 'kronoapp.auth', 'kronoapp.home.controllers', 'kronoapp.stores.services', 'kronoapp.stores.controllers', 'kronoapp.products.directives', 'kronoapp.products.services', 'kronoapp.basket.services', 'kronoapp.orders.services', 'kronoapp.orders.directives', 'kronoapp.orders.controllers', 'kronoapp.tutorials', 'kronoapp.services', 'kronoapp.directives', 'kronoapp.filters', 'kronoapp.controllers']).run(function($ionicPlatform, $rootScope, $state, $window, PARSE_APP_ID, PARSE_REST_KEY, SENDER_ID, DEBUG, $analytics, $localStorage, amMoment, versionChecker, IdleReloader, Device) {
  $rootScope.lastVisitedStore = $localStorage['lastStoreId'];
  $window['$rootScope'] = $rootScope;
  $rootScope.config = {
    'debug': DEBUG
  };
  console.log(angular);
  if ($rootScope.lastVisitedStore != null) {
    $window.location.href = '#/app/stores/' + $rootScope.lastVisitedStore + '/lobby';
  } else {
    $window.location.href = '#/app/home';
  }
  amMoment.changeLocale('es');
  Device.areNotificationsEnabled().then(function() {
    return Device.initializeNotifications(['client']);
  });
  Device.onNotification(function(notification) {
    if (notification.setHash) {
      $window.location.href = notification.setHash;
    }
    if (notification.pushId != null) {
      $analytics.eventTrack('Push open', {
        'pushId': notification.pushId
      });
      return console.log("Push open tracked with ID ''" + notification.pushId + "''");
    }
  });
  return $ionicPlatform.ready(function() {
    var plugins;
    if ($window.plugins) {
      plugins = [].concat(_($window.plugins).keys()).concat(_($window.cordova.plugins).keys());
      console.log("Cordova Plugins: " + plugins);
    }
    if ($window.cordova && $window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
    }
    if (navigator.splashscreen) {
      navigator.splashscreen.hide();
    }
    versionChecker.check();
    if ($window.StatusBar) {
      StatusBar.styleDefault();
    }
    IdleReloader.initialize();
    if (window.cordova) {
      GappTrack.track("933656598", "mumXCJKi72cQlvCZvQM", "0.00", false);
    } else {
      console.log("WARNING: No GappTrack plugin found");
    }
    return $analytics.eventTrack('Open App', {});
  });
}).config(function($stateProvider, $urlRouterProvider, i18nProvider, $ionicConfigProvider, RestangularProvider, BASE_URL) {
  $ionicConfigProvider.backButton.text('').previousTitleText(false);
  $ionicConfigProvider.views.swipeBackEnabled(false);
  RestangularProvider.setBaseUrl(BASE_URL);
  RestangularProvider.setRequestSuffix('/');
  i18nProvider.lang('en');
  $stateProvider.state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl',
    resolve: {
      i18n: function(i18n) {
        return i18n.loadTranslations("localizations/" + i18n.lang + ".json");
      }
    }
  }).state('app.feedback', {
    url: '/feedback',
    views: {
      'menuContent': {
        templateUrl: 'templates/feedback.html',
        controller: 'FeedbackCtrl'
      }
    }
  }).state('app.home', {
    url: '/home',
    views: {
      'menuContent': {
        templateUrl: 'templates/home/home.html',
        controller: 'HomeCtrl'
      }
    }
  }).state('app.store-lobby', {
    url: '/stores/:storeId/lobby',
    views: {
      'menuContent': {
        templateUrl: 'templates/stores/lobby.html',
        controller: 'LobbyCtrl'
      }
    }
  }).state('app.store-category', {
    url: '/stores/:storeId/categories/:categoryId',
    views: {
      'menuContent': {
        templateUrl: 'templates/stores/category.html',
        controller: 'CategoryCtrl'
      }
    }
  }).state('app.store-subcategory', {
    url: '/stores/:storeId/subcategories/:subcategoryId',
    views: {
      'menuContent': {
        templateUrl: 'templates/stores/subcategory.html',
        controller: 'SubcategoryCtrl'
      }
    }
  }).state('app.checkout', {
    url: '/stores/:storeId/checkout',
    views: {
      'menuContent': {
        templateUrl: 'templates/stores/checkout.html',
        controller: 'OrderCheckoutCtrl'
      }
    }
  }).state('app.order-summary', {
    url: '/stores/:storeId/order-summary',
    views: {
      'menuContent': {
        templateUrl: 'templates/stores/order_summary.html',
        controller: 'OrderSummaryCtrl'
      }
    }
  }).state('app.orders', {
    url: '/orders',
    views: {
      'menuContent': {
        templateUrl: 'templates/orders/list.html',
        controller: 'OrdersCtrl'
      }
    }
  }).state('app.order-detail', {
    url: '/orders/:orderId',
    views: {
      'menuContent': {
        templateUrl: 'templates/orders/detail.html',
        controller: 'OrderDetailCtrl'
      }
    }
  }).state('app.profile', {
    url: '/profile',
    views: {
      'menuContent': {
        templateUrl: 'templates/profile/profile.html',
        controller: 'ProfileCtrl'
      }
    }
  });
  return $urlRouterProvider.otherwise('/app/home');
});

var config, config_module;

config = {
  APP_NAME: 'KronoApp',
  DEBUG: false,
  SENDER_ID: '1076345567071',
  FACEBOOK_APP_ID: 776956362389659,
  IOS_APP_ID: 'id963754728',
  ANDROID_BUNDLE_ID: 'co.kronomarket.kronoapp',
  GOOGLE_PLUS_WEB_KEY: '968726114362-oc37f26kv415cvsthg6mq5dvrcl315ml.apps.googleusercontent.com',
  GOOGLE_ANALYTICS_KEY: 'UA-62090262-1',
  CRITTERCISM_IOS_KEY: '55561a928172e25e67906d64',
  CRITTERCISM_ANDROID_KEY: '55561aec7365f84f7d3d729e',
  SINGLE_STORE_ID: null
};

if (config.DEBUG) {
  config['BASE_URL'] = 'https://krono-dev.herokuapp.com/v1/';
  config['IMAGES_URL'] = 'https://media-dev.kronoapp.co/';
  config['FIREBASE_URI'] = 'https://krono-dev.firebaseio.com/';
  config['MIXPANEL_TOKEN'] = '62bfe4f46d0ee935bd2c75d093a5cbbc';
  config['PARSE_APP_ID'] = 'r50LG4poTpW4m10IMgofwyCpemHhlBjjwEwKnjiZ';
  config['PARSE_REST_KEY'] = 'ZlMrN81FhqScaI7X9rKvJ6JxC0I9f1SgJeafh26I';
  config['ANALYTICS_IGNORED_USERS'] = [];
} else {
  config['BASE_URL'] = 'https://krono.herokuapp.com/v1/';
  config['IMAGES_URL'] = 'https://media.kronoapp.co/';
  config['FIREBASE_URI'] = 'https://krono.firebaseio.com/';
  config['MIXPANEL_TOKEN'] = '748d2e83b637e032f27350f1426edb4f';
  config['PARSE_APP_ID'] = 'rYTjOt4PYVk1tg3LIuqftiQjhUp7L0vyqgbJZ9Xs';
  config['PARSE_REST_KEY'] = 'v1cZxDxMObNLS5jcfxzWMzprFPCf3JSsNBNeAoMp';
  config['ANALYTICS_IGNORED_USERS'] = ['google:107177038112942019453', 'facebook:1008188689196157', 'google:102344469034888300777', 'facebook:10153096632137952', 'google:100531525502724348401', 'facebook:10152953721851208', 'facebook:10153118691356098'];
}

config_module = angular.module("kronoapp.config", []);

angular.forEach(config, function(key, value) {
  return config_module.constant(value, key);
});

angular.module('kronoapp.controllers', []).controller('AppCtrl', function($scope, $window, $localStorage, $analytics, $timeout, $state, loginModal, PeopleAnalytics, WelcomeTutorial, ProductPickingTutorial, Auth, Device, Orders, basketModal, Basket, SINGLE_STORE_ID) {
  $scope.storeId = SINGLE_STORE_ID;
  if (SINGLE_STORE_ID !== null) {
    $scope.singleStore = true;
  } else {
    $scope.singleStore = false;
  }
  $scope.loginModal = new loginModal();
  $scope.login = function() {
    return $scope.loginModal.open();
  };
  $scope.logout = function() {
    $analytics.eventTrack('Logout', {});
    PeopleAnalytics.logout();
    Auth.unauth();
    return $window.location.reload(true);
  };
  $scope.closeKeyboard = function() {
    if ($window.cordova && $window.cordova.plugins.Keyboard) {
      return cordova.plugins.Keyboard.close();
    }
  };
  $scope.openUrl = function(url) {
    if ($window.cordova && $window.cordova.InAppBrowser) {
      return cordova.InAppBrowser.open(url, '_blank', 'location=yes');
    } else {
      return $window.open(url, '_blank');
    }
  };
  Auth.onAuthGetUser(function(user) {
    if (user != null) {
      $scope.user = user;
      $scope.orders = Orders.allFromUser(user);
      PeopleAnalytics.register(user);
      if (Device.getDeviceId() != null) {
        return Device.registerForUser(user);
      } else {
        return Device.onTokenReceived(function() {
          return Device.registerForUser(user);
        });
      }
    } else {
      return PeopleAnalytics.anonymousRegister(user);
    }
  });
  $scope.basket = Basket.getOrCreate($localStorage['basketId']);
  $localStorage['basketId'] = $scope.basket.$id;
  $scope.basketModal = new basketModal($scope.basket);
  $scope.basketModal.on('order', function(e, store, orderDescription) {
    $scope.orderDesc = orderDescription;
    if ($scope.user && $scope.user.isProfileComplete()) {
      return $state.go('app.checkout', {
        storeId: $scope.lastVisitedStore
      });
    } else {
      return $scope.loginModal.open('app.checkout', {
        storeId: $scope.lastVisitedStore
      });
    }
  });
  $scope.welcomeTutorial = new WelcomeTutorial();
  $scope.productPickingTutorial = new ProductPickingTutorial();
  return $scope.openTutorial = function() {
    return $scope.welcomeTutorial.open();
  };
}).controller('FeedbackCtrl', function(_, l, $scope, $analytics, Feedback, $ionicPopup) {
  var reset;
  $analytics.eventTrack('Page View', {
    'page': 'Feedback'
  }, {});
  reset = function() {
    $scope.feedback = {
      text: ''
    };
    return $scope.error = null;
  };
  reset();
  return $scope.send = function() {
    if ($scope.user) {
      $scope.feedback.userId = $scope.user._id;
    }
    $scope.error = null;
    $analytics.eventTrack('Feedback sent', {});
    if ($scope.feedback.text.length < 10) {
      $scope.error = l('%feedback.text.error.length');
    }
    if (!$scope.error) {
      $scope.sending = true;
      return Feedback.create($scope.feedback).$loaded()["finally"](function() {
        reset();
        $ionicPopup.alert({
          title: l('%global.message'),
          template: l('%feedback.sended')
        });
        return $scope.sending = false;
      });
    }
  };
});

var app;

app = angular.module("kronoapp.directives", []);

app.directive('loadingPlaceholder', function($timeout) {
  return {
    restrict: 'A',
    link: function(scope, element, attrs) {
      element.on('load', function() {
        return element.removeClass("loading");
      }).on('error', function() {});
      return scope.$watch('ngSrc', function(newVal) {
        element.addClass("loading");
        return element.css({
          'min-height': element[0].clientWidth + "px"
        });
      });
    }
  };
});

var hasProp = {}.hasOwnProperty;

angular.module('kronoapp.filters', []).filter('productSearch', function(_) {
  return function(array, query, limit) {
    var element, field, key, result;
    if (limit == null) {
      limit = 20;
    }
    if (query === '') {
      return [];
    }
    result = [];
    query = query.toLowerCase();
    for (key in array) {
      if (!hasProp.call(array, key)) continue;
      element = array[key];
      if (result.length >= limit) {
        break;
      }
      field = element.details.toLowerCase();
      if (~field.indexOf(query)) {
        result.push(element);
      }
    }
    return result;
  };
});

angular.module('kronoapp.services', []).factory('Feedback', function(_, $firebaseObject, FirebaseRef) {
  var Feedback, feedbacksRef, mainRef;
  mainRef = FirebaseRef.get();
  feedbacksRef = mainRef.child('feedback');
  Feedback = $firebaseObject.$extend({
    $$updated: function(feedbackSnapshot) {
      var changed;
      return changed = $firebaseObject.prototype.$$updated.apply(this, arguments);
    }
  });
  Feedback.get = function(id) {
    return new Feedback(feedbacksRef.child(id));
  };
  Feedback.create = function(data) {
    if (data == null) {
      data = void 0;
    }
    return new Feedback(feedbacksRef.push(data));
  };
  return Feedback;
}).factory('versionChecker', function(l, $cordovaAppVersion, $ionicPopup, $http, $q, $analytics, $window, IOS_APP_ID, ANDROID_BUNDLE_ID, FIREBASE_URI) {
  return {
    'check': function(alert) {
      var localVersionPromise, minimalVersionPromise;
      if (alert == null) {
        alert = true;
      }
      if (($window.cordova != null) && ($window.cordova.getAppVersion != null)) {
        localVersionPromise = $window.cordova.getAppVersion.getVersionNumber();
        minimalVersionPromise = this.getMinimalVersion();
        return $q.all([localVersionPromise, minimalVersionPromise]).then((function(_this) {
          return function(versions) {
            var analyticsData, localVersion, minimalVersion;
            localVersion = versions[0];
            minimalVersion = versions[1];
            console.log("localVersion: " + localVersion);
            console.log("minimalVersion: " + minimalVersion);
            if (_this.compareVersions(localVersion, minimalVersion) < 0) {
              analyticsData = {
                'platform': ionic.Platform.platform(),
                'localVersion': localVersion,
                'minimalVersion': minimalVersion
              };
              $analytics.eventTrack('Outdated App', analyticsData);
              if (alert) {
                return $ionicPopup.confirm({
                  title: l('%global.app_outdated.title'),
                  template: l('%global.app_outdated.text'),
                  cancelText: l('%global.app_outdated.later'),
                  okText: l('%global.app_outdated.update')
                }).then(function(confirmed) {
                  var url;
                  if (confirmed) {
                    $analytics.eventTrack('Update confirmation accepted', analyticsData);
                    if (ionic.Platform.isIOS()) {
                      url = "itms://itunes.apple.com/app/apple-store/" + IOS_APP_ID + "?mt=8";
                    } else if (ionic.Platform.isAndroid()) {
                      url = "market://details?id=" + ANDROID_BUNDLE_ID;
                    }
                    return window.open(url, '_system');
                  } else {
                    return $analytics.eventTrack('Update confirmation rejected', analyticsData);
                  }
                });
              }
            }
          };
        })(this));
      } else {
        return console.log("Local version not found");
      }
    },
    'getMinimalVersion': function() {
      return $http.get(FIREBASE_URI + "/clients_versions/" + (ionic.Platform.platform()) + "/minimal.json").then(function(result) {
        return result.data;
      });
    },
    'compareVersions': function(versionA, versionB) {
      var diff, numberA, numberB;
      numberA = this.versionToNumber(versionA);
      numberB = this.versionToNumber(versionB);
      diff = numberA - numberB;
      return diff / (Math.abs(diff) || 1);
    },
    'versionToNumber': function(version) {
      return _(version.split(".").reverse()).reduce(function(sum, digit, index) {
        return sum + Number(digit) * Math.pow(1000, index);
      }, 0);
    }
  };
}).service('FirebaseRef', function(FIREBASE_URI) {
  var mainRef;
  mainRef = new Firebase(FIREBASE_URI);
  this.get = function() {
    return mainRef;
  };
  this.TIMESTAMP = Firebase.ServerValue.TIMESTAMP;
}).service('AmountOfTimesOpen', function($localStorage) {
  this.opened = function(objId, parentId, propertyName) {
    var amountOpens, newObj, obj;
    obj = $localStorage[propertyName];
    if (!obj) {
      newObj = {};
      newObj[parentId] = {};
      newObj[parentId][objId] = {
        opens: 1
      };
      return $localStorage[propertyName] = newObj;
    } else {
      if (obj[parentId]) {
        if (obj[parentId][objId]) {
          amountOpens = obj[parentId][objId].opens;
          return obj[parentId][objId].opens = amountOpens + 1;
        } else {
          return obj[parentId][objId] = {
            opens: 1
          };
        }
      } else {
        obj[parentId] = {};
        return obj[parentId][objId] = {
          opens: 1
        };
      }
    }
  };
  this.getOpens = function(objId, parentId, propertyName) {
    var amountOpens, obj;
    obj = $localStorage[propertyName];
    if (obj) {
      if (obj[parentId]) {
        if (obj[parentId][objId]) {
          return amountOpens = obj[parentId][objId].opens;
        } else {
          return 0;
        }
      } else {
        return 0;
      }
    } else {
      return 0;
    }
  };
});

var app;

app = angular.module("i18n.directives", []);

app.directive('translate', function(l) {
  return {
    restrict: 'A',
    priority: 1,
    link: function(scope, iElement, iAttrs) {
      return scope.$watch(iAttrs.ngBind, function(new_binded_value) {
        return iElement.text(l(iElement.text().trim()));
      });
    }
  };
});

angular.module("i18n.filters", []).filter("translate", function(l) {
  return function(text, args) {
    return l(text, args);
  };
});

angular.module("i18n", ['i18n.directives', 'i18n.services', 'i18n.filters']).provider("i18n", function() {
  var lang, translations;
  lang = 'en';
  translations = {
    'hola': 'hello'
  };
  this.lang = function(val) {
    if (val != null) {
      return lang = val;
    }
  };
  this.translations = function(val) {
    if (val != null) {
      return lang = val;
    }
  };
  this.$get = [
    '$http', '$q', function($http, $q) {
      return {
        lang: lang,
        translations: translations,
        loadTranslations: function(url) {
          var deferred;
          deferred = $q.defer();
          $http.get(url).success((function(_this) {
            return function(result) {
              _this.translations = JSON.parse(JSON.stringify(result));
              return deferred.resolve(_this);
            };
          })(this));
          return deferred.promise;
        },
        translate: function(key, args) {
          var a, arg, i, len, value;
          if (!(typeof args === "object" && args instanceof Array)) {
            if (typeof args === "string" || typeof args === "number") {
              args = [args];
            } else {
              args = [];
            }
          }
          value = this.translations[key];
          if (value == null) {
            value = key;
          }
          for (a = i = 0, len = args.length; i < len; a = ++i) {
            arg = args[a];
            value = value.replace("{" + a + "}", arg);
          }
          return value;
        }
      };
    }
  ];
});

angular.module("i18n.services", []).factory("translate", function(i18n) {
  return function(text, args) {
    return i18n.translate(text, args);
  };
}).factory("l", function(translate) {
  return function(text, args) {
    return translate(text, args);
  };
});

angular.module("utils.directives", []).directive('preload', function() {
  return {
    restrict: 'A',
    link: function(scope, element, attrs) {
      element.on('load', function() {
        return element.removeClass("loading");
      }).on('error', function() {});
      return scope.$watch('ngSrc', function(newVal) {
        return element.addClass("loading");
      });
    }
  };
}).directive('doubleTap', function($timeout) {
  return {
    restrict: 'A',
    link: function(scope, element, attrs) {
      var lastTapPromise;
      lastTapPromise = null;
      return element.on('click', function() {
        if (lastTapPromise != null) {
          $timeout.cancel(lastTapPromise);
          lastTapPromise = null;
          return scope.$eval(attrs.doubleTap);
        } else {
          return lastTapPromise = $timeout((function() {
            lastTapPromise = null;
            if (attrs.singleTap) {
              return scope.$eval(attrs.singleTap);
            }
          }), 300);
        }
      });
    }
  };
}).directive('autoFocus', function($timeout) {
  return {
    link: function(scope, element, attrs) {
      return $timeout((function() {
        element[0].focus();
        if (ionic.Platform.isAndroid()) {
          return cordova.plugins.Keyboard.show();
        }
      }), 150);
    }
  };
}).directive('doFocus', function() {
  return {
    link: function(scope, element, attrs) {
      return scope.$watch(attrs.doFocus, function(value) {
        if (value === true) {
          element[0].focus();
          return scope.$eval(attrs.doFocus + "=false");
        }
      });
    }
  };
}).directive('doBlur', function() {
  return {
    link: function(scope, element, attrs) {
      return scope.$watch(attrs.doBlur, function(value) {
        if (value === true) {
          element[0].blur();
          return scope.$eval(attrs.doBlur + "=false");
        }
      });
    }
  };
}).directive('ngEnter', function() {
  return function(scope, element, attrs) {
    return element.bind('keydown keypress', function(event) {
      if (event.which === 13) {
        scope.$apply(function() {
          return scope.$eval(attrs.ngEnter);
        });
        return event.preventDefault();
      }
    });
  };
});

angular.module('utils.push_v5', []).factory('$cordovaPushV5', function($window, $q, $rootScope, $timeout) {

  /*global PushNotification */
  var push;
  push = void 0;
  return {
    register: function(options) {
      var q, registered;
      q = $q.defer();
      registered = false;
      push = $window.PushNotification.init(options);
      push.on('notification', function(notification) {
        $timeout(function() {
          $rootScope.$emit('$cordovaPushV5:notificationReceived', notification);
        });
      });
      push.on('error', function(error) {
        if (!registered) {
          registered = true;
          q.reject(error);
          return;
        }
        $timeout(function() {
          $rootScope.$emit('$cordovaPushV5:errorOccurred', error);
        });
      });
      push.on('registration', function(data) {
        q.resolve(data.registrationId);
      });
      return q.promise;
    },
    unregister: function() {
      var q;
      q = $q.defer();
      if (push === void 0) {
        q.reject(new Error('register must be called before any other operation'));
      } else {
        push.unregister((function(success) {
          q.resolve(success);
        }), function(error) {
          q.reject(error);
        });
      }
      return q.promise;
    },
    setBadgeNumber: function(number) {
      var q;
      q = $q.defer();
      if (push === void 0) {
        q.reject(new Error('register must be called before any other operation'));
      } else {
        push.setApplicationIconBadgeNumber((function(success) {
          q.resolve(success);
        }), (function(error) {
          q.reject(error);
        }), number);
      }
      return q.promise;
    }
  };
});

angular.module('utils.services', []).factory('IdleReloader', function(_, $analytics, $ionicPlatform, $window) {
  var beginTime, pauseTime;
  pauseTime = 0;
  beginTime = 0;
  return {
    'initialize': function(reloadTime, initialURL) {
      if (reloadTime == null) {
        reloadTime = 20 * 60 * 1000;
      }
      if (initialURL == null) {
        initialURL = '/';
      }
      $ionicPlatform.on('resume', (function(_this) {
        return function() {
          return _this.onResume(reloadTime, initialURL);
        };
      })(this));
      $ionicPlatform.on('pause', (function(_this) {
        return function() {
          return _this.onPause();
        };
      })(this));
      return console.log("IdleReloader Initialized");
    },
    'onResume': function(reloadTime, initialURL) {
      var diff, now;
      if (reloadTime == null) {
        reloadTime = 20 * 60 * 1000;
      }
      if (initialURL == null) {
        initialURL = '/';
      }
      now = Date.now();
      diff = now - pauseTime;
      console.log("IdleReloader: Begin session " + now + ", diff " + diff);
      if (diff > reloadTime) {
        console.log("Reloading App to '" + initialURL + "'");
        $analytics.eventTrack("Restart by Idle", {});
        $window.location.reload(true);
        return console.log("Reloading App to '" + initialURL + "'");
      }
    },
    'onPause': function() {
      pauseTime = Date.now();
      return console.log("IdleReloader: Finishing session " + pauseTime);
    }
  };
}).factory('Geometry', function() {
  var toRad;
  toRad = function(number) {
    return number * Math.PI / 180;
  };
  return {
    'haversineDistance': function(lat1, lon1, lat2, lon2, earthRadius) {
      var a, c, dLat, dLon, x1, x2;
      if (earthRadius == null) {
        earthRadius = 6371;
      }
      x1 = lat2 - lat1;
      dLat = toRad(x1);
      x2 = lon2 - lon1;
      dLon = toRad(x2);
      a = Math.sin(dLat / 2) * Math.sin(dLat / 2) + Math.cos(toRad(lat1)) * Math.cos(toRad(lat2)) * Math.sin(dLon / 2) * Math.sin(dLon / 2);
      c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
      return earthRadius * c;
    }
  };
}).factory('StringManipulation', function() {
  return {
    'padding': function(number, width, filled) {
      var newNumber;
      filled = filled || '0';
      number = number + '';
      if (number.length >= width) {
        return number;
      } else {
        newNumber = new Array(width - number.length + 1).join(filled) + number;
        return newNumber;
      }
    }
  };
});

angular.module('kronoapp.auth.controllers', []);

angular.module('kronoapp.auth', ['ionic', 'kronoapp.auth.services', 'kronoapp.auth.controllers']).run(function($ionicPlatform, FACEBOOK_APP_ID) {
  return $ionicPlatform.ready(function() {
    var body, facebookRoot, facebookScript;
    if (ionic.Platform.is("browser")) {
      console.log("Adding facebook scripts for browser");
      facebookScript = document.createElement('script');
      facebookScript.setAttribute('src', 'js/facebook-connect-plugin.js');
      facebookRoot = document.createElement('dom');
      facebookRoot.setAttribute('id', 'fb-root');
      body = document.getElementsByTagName('body')[0];
      body.appendChild(facebookRoot);
      return body.appendChild(facebookScript);
    }
  });
}).config(function() {});

angular.module('kronoapp.auth.services', ['ngCordovaOauth']).factory('Auth', function(_, $q, $window, $ionicPlatform, $firebaseAuth, $localStorage, $cordovaOauth, FirebaseRef, User, FACEBOOK_APP_ID, GOOGLE_PLUS_WEB_KEY) {
  var authObj;
  authObj = $firebaseAuth(FirebaseRef.get());
  return {
    unauth: function() {
      authObj.$unauth();
      return $window.localStorage.clear();
    },
    onAuthGetUser: function(callback, once) {
      var offAuth;
      if (once == null) {
        once = false;
      }
      return offAuth = authObj.$onAuth(function(authData) {
        if (once) {
          offAuth();
        }
        if (authData) {
          return User.get(authData.uid).$loaded().then(callback);
        } else {
          return callback(null);
        }
      });
    },
    passwordLogin: function(formData) {
      var mainRef;
      mainRef = FirebaseRef.get();
      return authObj.$authWithPassword({
        email: formData.email,
        password: formData.password
      }).then(function(authData) {
        var user;
        console.log("User authenticated on Firebase using a Form");
        user = User.get(authData.uid);
        return user.$loaded().then(function() {
          return $q.when({
            'user': user,
            'authData': authData
          }).then(function(obj) {
            obj.user.setOauthProviderInfo(obj.authData);
            return obj.user.$save().then(function() {
              return $q.when(obj.user);
            });
          });
        });
      })["catch"](function(error) {
        return authObj.$createUser({
          email: formData.email,
          password: formData.password
        }).then(function(userData) {
          console.log("User created successfully!");
          return authObj.$authWithPassword({
            email: formData.email,
            password: formData.password
          }).then(function(authData) {
            var user;
            console.log("User authenticated on Firebase using a Form");
            user = User.get(authData.uid);
            return user.$loaded().then(function() {
              return $q.when({
                'user': user,
                'authData': authData
              }).then(function(obj) {
                obj.user.setOauthProviderInfo(obj.authData);
                return obj.user.$save().then(function() {
                  return $q.when(obj.user);
                });
              });
            });
          })["catch"](function(error) {
            return $q.reject(error);
          });
        })["catch"](function(error) {
          return $q.reject(error);
        });
      });
    },
    googlePlusLogin: function() {
      var mainRef;
      mainRef = FirebaseRef.get();
      return $cordovaOauth.google(GOOGLE_PLUS_WEB_KEY, ['profile', 'email']).then(function(loginResult) {
        console.log("userObject: " + JSON.stringify(loginResult));
        return authObj.$authWithOAuthToken('google', loginResult.access_token).then(function(authData) {
          var user;
          console.log("User authenticated on Firebase using Google+");
          user = User.get(authData.uid);
          return user.$loaded().then(function() {
            return $q.when({
              'user': user,
              'authData': authData
            });
          });
        });
      }).then(function(obj) {
        obj.user.setOauthProviderInfo(obj.authData);
        return obj.user.$save().then(function() {
          return $q.when(obj.user);
        });
      })["catch"](function(error) {
        return $q.reject(error);
      });
    },
    facebookLogin: function() {
      var deferred, mainRef;
      mainRef = FirebaseRef.get();
      deferred = $q.defer();
      if (ionic.Platform.is("browser")) {
        facebookConnectPlugin.browserInit(FACEBOOK_APP_ID);
      }
      facebookConnectPlugin.login(['public_profile', 'email', 'user_birthday'], (function(status) {
        deferred.notify({
          event: 'facebookConnect.status',
          data: status
        });
        return facebookConnectPlugin.getAccessToken((function(token) {
          deferred.notify({
            event: 'facebookConnect.token',
            data: token
          });
          return authObj.$authWithOAuthToken('facebook', token).then(function(authData) {
            var user;
            deferred.notify({
              event: 'firebase.authData',
              data: authData
            });
            user = User.get(authData.uid);
            return user.$loaded().then(function() {
              return $q.when({
                'user': user,
                'authData': authData
              });
            });
          }).then(function(obj) {
            obj.user.setOauthProviderInfo(obj.authData);
            return obj.user.$save().then(function() {
              return $q.when(obj.user);
            });
          }).then(function(user) {
            return deferred.resolve(user);
          })["catch"](function(error) {
            return deferred.reject(error);
          });
        }), function(error) {
          return deferred.reject(error);
        });
      }), function(error) {
        return deferred.reject(error);
      });
      return deferred.promise;
    }
  };
}).factory('User', function(_, $firebaseObject, FirebaseRef) {
  var User, mainRef, usersQueriesRef, usersRef;
  mainRef = FirebaseRef.get();
  usersRef = mainRef.child('users');
  usersQueriesRef = mainRef.child('queries').child('users');
  User = $firebaseObject.$extend({
    $$updated: function(userSnapshot) {
      var changed;
      this._id = this.$id;
      changed = $firebaseObject.prototype.$$updated.apply(this, arguments);
      if (this.document) {
        return this.document = Number(this.document) || 0;
      }
    },
    ordersRef: function() {
      return usersQueriesRef.child(this.$id).child('orders');
    },
    setOauthProviderInfo: function(AuthData) {
      var ProviderInfo, displayName, email, picture, provider;
      provider = AuthData.provider;
      ProviderInfo = AuthData[provider];
      displayName = ProviderInfo.displayName;
      email = ProviderInfo.email || ProviderInfo.cachedUserProfile.email;
      if (displayName) {
        this.name = displayName;
      }
      if (email) {
        this.email = email;
      }
      if (provider === 'facebook') {
        picture = ProviderInfo.cachedUserProfile.picture.data.url;
      }
      if (provider === 'google') {
        picture = ProviderInfo.cachedUserProfile.picture;
      }
      if (provider === 'password') {
        picture = ProviderInfo.profileImageURL;
      }
      if (picture) {
        this.picture = picture;
      }
      if (!provider === 'password') {
        this[provider + '_data'] = ProviderInfo.cachedUserProfile;
      }
      return this;
    },
    isProfileComplete: function() {
      return (this.phone != null) && (this.document != null) && (this.email != null);
    }
  });
  User.get = function(id) {
    return new User(usersRef.child(id));
  };
  return User;
}).factory('loginModal', function(l, $ionicModal, $rootScope, $ionicPlatform, $ionicPopup, $ionicLoading, $state, $http, $q, $analytics, $window, Auth) {
  var LoginModal;
  LoginModal = (function() {
    LoginModal.prototype.scope = null;

    LoginModal.prototype.promise = null;

    LoginModal.prototype._redirectState = null;

    LoginModal.prototype._stateData = null;

    function LoginModal() {
      var loginErrorParser;
      this.scope = $rootScope.$new();
      this.scope.passwordLoginData = {};
      this.promise = $ionicModal.fromTemplateUrl('templates/auth/login.html', {
        scope: this.scope,
        animation: 'slide-in-up',
        hardwareBackButtonClose: false,
        backdropClickToClose: false
      }).then((function(_this) {
        return function(modal) {
          _this.scope.modal = modal;
          return modal;
        };
      })(this));
      this.scope.$watch('inProcess', (function(_this) {
        return function() {
          if (_this.scope.inProcess) {
            return $ionicLoading.show();
          } else {
            return $ionicLoading.hide();
          }
        };
      })(this));
      loginErrorParser = function(error) {
        var networkError;
        networkError = error === "An SSL error has occurred and a secure connection to the server cannot be made." || error.code === "NETWORK_ERROR";
        if (networkError) {
          return l("%login.error.network_error");
        } else if (error.errorCode === "4201") {
          return l("%login.error.android_facebook_cancel");
        } else if (error.code === "EMAIL_TAKEN" || error.code === "INVALID_EMAIL" || error.code === "INVALID_PASSWORD" || error.code === "INVALID_USER") {
          return l("%login.error.wrong.password-email");
        } else {
          console.error("Login error " + (JSON.stringify(error)));
          $analytics.eventTrack('Error', {
            'action': 'login',
            'info': JSON.stringify(error)
          });
          return l("%login.error.unknown");
        }
      };
      this.scope.open = (function(_this) {
        return function() {
          $analytics.eventTrack('Open login modal', {});
          _this.scope.user = null;
          _this.scope.userExtra = {};
          return _this.scope.modal.show();
        };
      })(this);
      this.scope.close = (function(_this) {
        return function(redirect) {
          if (redirect == null) {
            redirect = false;
          }
          $analytics.eventTrack('Close login modal', {});
          _this.scope.modal.hide();
          if (redirect && (_this._redirectState != null)) {
            return $state.go(_this._redirectState, _this._stateData);
          }
        };
      })(this);
      this.scope.$on('$destroy', (function(_this) {
        return function() {
          return _this.scope.modal.remove();
        };
      })(this));
      this.scope.passwordLogin = (function(_this) {
        return function() {
          if (!_this.scope.inProcess) {
            if (_this.scope.passwordLoginData.form.$valid) {
              _this.scope.inProcess = true;
              $analytics.eventTrack('Email Login', {});
              return Auth.passwordLogin(_this.scope.passwordLoginData).then(function(user) {
                _this.scope.inProcess = false;
                if (!user.isProfileComplete()) {
                  return _this.scope.user = user;
                } else {
                  return _this.close(true);
                }
              }, function(error) {
                var userCanceled;
                _this.scope.inProcess = false;
                userCanceled = !((error != null) && error !== "The sign in flow was canceled");
                if (!userCanceled) {
                  return $ionicPopup.alert({
                    title: l('%global.error'),
                    template: l('%login.error_{0}', loginErrorParser(error))
                  });
                }
              }, function(msg) {
                return console.log(msg);
              });
            }
          }
        };
      })(this);
      this.scope.googleLogin = (function(_this) {
        return function() {
          if (!_this.scope.inProcess) {
            _this.scope.inProcess = true;
            $analytics.eventTrack('Google Login', {});
            return Auth.googlePlusLogin().then(function(user) {
              _this.scope.inProcess = false;
              if (!user.isProfileComplete()) {
                return _this.scope.user = user;
              } else {
                return _this.close(true);
              }
            }, function(error) {
              var userCanceled;
              _this.scope.inProcess = false;
              userCanceled = !((error != null) && error !== "The sign in flow was canceled");
              if (!userCanceled) {
                return $ionicPopup.alert({
                  title: l('%global.error'),
                  template: l('%login.error_{0}', loginErrorParser(error))
                });
              }
            }, function(msg) {
              return console.log(msg);
            });
          }
        };
      })(this);
      this.scope.facebookLogin = (function(_this) {
        return function() {
          if (!_this.scope.inProcess) {
            _this.scope.inProcess = true;
            $analytics.eventTrack('Facebook Login', {});
            return Auth.facebookLogin().then(function(user) {
              _this.scope.inProcess = false;
              if (!user.isProfileComplete()) {
                return _this.scope.user = user;
              } else {
                return _this.close(true);
              }
            }, function(error) {
              var userCanceled;
              _this.scope.inProcess = false;
              userCanceled = !((error != null) && error !== "Permission denied.");
              if (!userCanceled) {
                return $ionicPopup.alert({
                  title: l('%global.error'),
                  template: l('%login.error_{0}', loginErrorParser(error))
                });
              }
            }, function(msg) {
              return console.log(msg);
            });
          }
        };
      })(this);
      this.scope.extraInfo = {
        verifyEmail: function(address) {
          var apiKey, url;
          apiKey = 'pubkey-6571db2c611d4e8b6393ddb3193b7ee0';
          url = "https://api.mailgun.net/v3/address/validate?api_key=" + apiKey + "&address=" + address;
          return $http.get(url, {
            'timeout': 3000
          }).then(function(result) {
            if (result.data.did_you_mean != null) {
              return $q.reject({
                'correction': result.data.did_you_mean,
                'valid': result.data.is_valid
              });
            } else {
              if (result.data.is_valid) {
                return address;
              } else {
                return $q.reject({});
              }
            }
          }, function(error) {
            return address;
          });
        },
        submit: (function(_this) {
          return function() {
            var error, error_msg, saveUser;
            if (!_this.scope.inProcess) {
              if (_this.scope.extraInfo.form.$valid) {
                _this.scope.inProcess = true;
                saveUser = function() {
                  _this.scope.inProcess = true;
                  _(_this.scope.user).extend(_this.scope.userExtra);
                  return _this.scope.user.$save().then(function() {
                    $window.fbq('track', 'CompleteRegistration');
                    mixpanel.alias(_this.scope.user.$id);
                    _this.scope.inProcess = false;
                    return _this.close(true);
                  }, function(error) {
                    return _this.scope.inProcess = false;
                  });
                };
                if (_this.scope.userExtra.email) {
                  return _this.scope.extraInfo.verifyEmail(_this.scope.userExtra.email).then(function(result) {
                    return saveUser();
                  })["catch"](function(error) {
                    var popupScope;
                    _this.scope.inProcess = false;
                    if (error.correction != null) {
                      popupScope = $rootScope.$new();
                      popupScope.correctedEmail = error.correction;
                      return $ionicPopup.show({
                        title: l('%login.extra-data.error.correct_email.title'),
                        subTitle: l('%login.extra-data.error.correct_email.text_{0}', _this.scope.userExtra.email),
                        template: '<input type="email" ng-model="correctedEmail">',
                        scope: popupScope,
                        buttons: [
                          {
                            text: l('%login.extra-data.error.correct_email.cancel')
                          }, {
                            text: l('%login.extra-data.error.correct_email.change'),
                            type: 'button-positive',
                            onTap: function() {
                              _this.scope.userExtra.email = popupScope.correctedEmail;
                              return saveUser();
                            }
                          }
                        ]
                      });
                    } else {
                      return $ionicPopup.alert({
                        title: l('%login.extra-data.error.reject_email.title'),
                        template: l('%login.extra-data.error.reject_email.text')
                      });
                    }
                  });
                } else {
                  return saveUser();
                }
              } else {
                error = _this.scope.extraInfo.form.$error;
                error_msg = null;
                if (error.email) {
                  error_msg = l('%login.extra-data.error.email');
                } else if (error.number && _(error.number).findWhere({
                  '$name': 'document'
                })) {
                  error_msg = l('%login.extra-data.error.document.number');
                } else if (error.required != null) {
                  error_msg = l('%login.extra-data.error.required');
                } else {
                  error_msg = l('%login.extra-data.error.unknown');
                }
                return $ionicPopup.alert({
                  title: l('%global.alert'),
                  template: error_msg
                });
              }
            }
          };
        })(this)
      };
      return;
    }

    LoginModal.prototype.open = function(redirectState, stateData) {
      if (redirectState == null) {
        redirectState = null;
      }
      if (stateData == null) {
        stateData = {};
      }
      this._redirectState = redirectState;
      this._stateData = stateData;
      return this.scope.open();
    };

    LoginModal.prototype.close = function(redirect) {
      if (redirect == null) {
        redirect = false;
      }
      return this.scope.close(redirect);
    };

    LoginModal.prototype.remove = function() {
      return this.scope.modal.remove();
    };

    LoginModal.prototype.on = function(ev, cb) {
      return this.scope.$on(ev, cb);
    };

    return LoginModal;

  })();
  return LoginModal;
});

angular.module('kronoapp.basket.services', []).factory('Basket', function(_, $firebaseObject, FirebaseRef, IMAGES_URL) {
  var Basket, basketsRef, mainRef;
  mainRef = FirebaseRef.get();
  basketsRef = mainRef.child('baskets');
  Basket = $firebaseObject.$extend({
    setStore: function(storeId) {
      return this.$ref().child('storeId').set(storeId);
    },
    addItem: function(itemId, item) {
      return this.$ref().child('items').child(itemId).set(item);
    },
    removeItem: function(itemId) {
      return this.$ref().child('items').child(itemId).remove();
    },
    setItemQuantity: function(itemId, quantity) {
      return this.$ref().child('items').child(itemId).child('quantity').set(quantity);
    },
    resetItems: function() {
      return this.$ref().child('items').remove();
    },
    onNewItem: function(callback) {
      return this.$ref().child('items').on('child_added', function(childSnapshot) {
        return callback(childSnapshot.key(), childSnapshot.val());
      });
    },
    clear: function() {
      return this.$ref().remove();
    },
    containsProductsOf: function(store) {
      return (store.$id === this.storeId) && this.items && _(this.items).keys().length;
    },
    containsProductsOfOtherThan: function(store) {
      return (store.$id !== this.storeId) && this.items && _(this.items).keys().length;
    }
  });
  Basket.get = function(id) {
    return new Basket(basketsRef.child(id));
  };
  Basket.getOrCreate = function(id) {
    if (id) {
      return Basket.get(id);
    } else {
      return new Basket(basketsRef.push());
    }
  };
  return Basket;
}).factory('basketModal', function($ionicModal, $rootScope, $timeout, StockItem, $analytics, $window, $ionicPopup, l) {
  var BasketModal;
  BasketModal = (function() {
    BasketModal.prototype.scope = null;

    BasketModal.prototype.store = null;

    BasketModal.prototype.promise = null;

    BasketModal.prototype.model = null;

    BasketModal.prototype.itemAdded = false;

    function BasketModal(basket) {
      this.scope = $rootScope.$new();
      this.promise = $ionicModal.fromTemplateUrl('templates/basket/modal.html', {
        scope: this.scope,
        animation: 'slide-in-up'
      }).then((function(_this) {
        return function(modal) {
          _this.scope.modal = modal;
          return modal;
        };
      })(this));
      this.model = basket;
      this.scope.open = (function(_this) {
        return function() {
          $analytics.eventTrack('Open basket modal', {
            'store': _this.store.name,
            'differentItems': _this.scope.basket.items.length,
            'itemsCount': _this.scope.basket.count,
            'basketTotal': _this.scope.basket.total
          });
          return _this.scope.modal.show();
        };
      })(this);
      this.scope.close = (function(_this) {
        return function() {
          $analytics.eventTrack('Close basket modal', {
            'store': _this.store.name,
            'differentItems': _this.scope.basket.items.length,
            'itemsCount': _this.scope.basket.count,
            'basketTotal': _this.scope.basket.total
          });
          return _this.scope.modal.hide();
        };
      })(this);
      this.scope.canOrder = (function(_this) {
        return function() {
          return _this.canOrder();
        };
      })(this);
      this.scope.overMinimumPurchase = (function(_this) {
        return function() {
          return _this.overMinimumPurchase();
        };
      })(this);
      this.scope.minimumPurchase = (function(_this) {
        return function() {
          return _this.minimumPurchase();
        };
      })(this);
      this.scope.$on('$destroy', (function(_this) {
        return function() {
          return _this.scope.modal.remove();
        };
      })(this));
      this.scope.order = (function(_this) {
        return function() {
          var popupScope;
          if (_this.canOrder()) {
            _this.scope.$emit('order', _this.store, _this.createOrderDescription());
            return _this.close();
          } else {
            popupScope = _this.scope.$new();
            popupScope.storeName = _this.store.name;
            popupScope.minimumPurchase = _this.minimumPurchase();
            return $ionicPopup.alert({
              templateUrl: 'templates/basket/alertMinimunPurchase.html',
              scope: popupScope
            });
          }
        };
      })(this);
      this.scope.basket = {
        items: [],
        total: 0,
        count: 0,
        indexedItems: {},
        find: (function(_this) {
          return function(stockItemId) {
            return _this.find(stockItemId);
          };
        })(this),
        addItem: (function(_this) {
          return function(stockItem) {
            return _this.addItem(stockItem);
          };
        })(this),
        removeItem: (function(_this) {
          return function(stockItem, removeAll) {
            return _this.removeItem(stockItem, removeAll);
          };
        })(this)
      };
      return;
    }

    BasketModal.prototype.open = function() {
      return this.scope.open();
    };

    BasketModal.prototype.close = function() {
      return this.scope.close();
    };

    BasketModal.prototype.remove = function() {
      return this.scope.modal.remove();
    };

    BasketModal.prototype.count = function() {
      return this.scope.basket.count;
    };

    BasketModal.prototype._flashItemAdded = function() {
      if (!this.itemAdded) {
        $timeout(((function(_this) {
          return function() {
            return _this.itemAdded = false;
          };
        })(this)), 1000);
      }
      return this.itemAdded = true;
    };

    BasketModal.prototype.createOrderDescription = function() {
      var item;
      return {
        'storeId': this.store.$id,
        'items': (function() {
          var i, len, ref, results;
          ref = this.scope.basket.items;
          results = [];
          for (i = 0, len = ref.length; i < len; i++) {
            item = ref[i];
            results.push({
              'price': item.price,
              'quantity': item.quantity,
              'productId': item.$product.$id,
              'stockItemId': item.$id
            });
          }
          return results;
        }).call(this),
        '$total': this.total()
      };
    };

    BasketModal.prototype.total = function() {
      return this.scope.basket.total;
    };

    BasketModal.prototype.on = function(ev, cb) {
      return this.scope.$on(ev, cb);
    };

    BasketModal.prototype.minimumPurchase = function() {
      if (this.store) {
        return this.store.minimumPurchase || 1;
      } else {
        return 1;
      }
    };

    BasketModal.prototype.canOrder = function() {
      return this.overMinimumPurchase();
    };

    BasketModal.prototype.overMinimumPurchase = function() {
      return this.store && this.scope.basket.total >= (this.store.minimumPurchase || 1);
    };

    BasketModal.prototype.setStore = function(store, sync) {
      if (sync == null) {
        sync = true;
      }
      if (store.$id !== this.model.storeId) {
        this.store = store;
        this.model.setStore(store.$id);
        return this.resetBasket(sync);
      } else if (!this.store) {
        this.store = store;
        return this._syncItemsWithModel(store);
      }
    };

    BasketModal.prototype.resetBasket = function(sync) {
      if (sync == null) {
        sync = true;
      }
      this.scope.basket.items = [];
      this.scope.basket.total = 0;
      this.scope.basket.count = 0;
      this.scope.basket.indexedItems = {};
      if (sync) {
        return this.model.resetItems();
      }
    };

    BasketModal.prototype.find = function(stockItemId) {
      return this.scope.basket.indexedItems[stockItemId];
    };

    BasketModal.prototype.addItem = function(stockItem, quantity, sync) {
      var basketItem;
      if (quantity == null) {
        quantity = 1;
      }
      if (sync == null) {
        sync = true;
      }
      basketItem = this.scope.basket.indexedItems[stockItem.$id];
      if (basketItem == null) {
        $window.fbq('track', 'AddToCart');
        basketItem = stockItem;
        basketItem.quantity = 0;
        this._add(basketItem, sync);
      }
      if (sync) {
        this._flashItemAdded();
        $analytics.eventTrack('Item Picked', {
          'store': this.store.name,
          'product': stockItem.$product.name,
          'productId': stockItem.$product.$id
        });
      }
      basketItem.quantity += quantity;
      if (sync) {
        this.model.setItemQuantity(basketItem.$id, basketItem.quantity);
      }
      return this.recalculate();
    };

    BasketModal.prototype.addItemById = function(stockItemId, quantity, sync) {
      if (quantity == null) {
        quantity = 1;
      }
      if (sync == null) {
        sync = true;
      }
      if (!this.store) {
        throw new Error("the basketModal must have a store defined");
      }
      console.log("Requesting item: " + stockItemId);
      return StockItem.get(stockItemId).$loaded().then((function(_this) {
        return function(stockItem) {
          console.log("Item resolved: " + stockItemId);
          _this.addItem(stockItem, quantity, sync);
          return stockItem;
        };
      })(this));
    };

    BasketModal.prototype.removeItem = function(stockItem, removeAll, sync) {
      var basketItem;
      if (removeAll == null) {
        removeAll = false;
      }
      if (sync == null) {
        sync = true;
      }
      basketItem = this.scope.basket.indexedItems[stockItem.$id];
      if (basketItem != null) {
        basketItem.quantity--;
        if (sync) {
          this.model.setItemQuantity(basketItem.$id, basketItem.quantity);
        }
        if (removeAll || basketItem.quantity < 1) {
          this._remove(basketItem, sync);
        }
        return this.recalculate();
      }
    };

    BasketModal.prototype.recalculate = function() {
      var count, total;
      total = 0;
      count = 0;
      _(this.scope.basket.items).each(function(item) {
        count += Number(item.quantity);
        return total += Number(item.price) * Number(item.quantity);
      });
      this.scope.basket.total = total;
      return this.scope.basket.count = count;
    };

    BasketModal.prototype._add = function(item, sync) {
      if (sync == null) {
        sync = true;
      }
      this.scope.basket.items.unshift(item);
      this.scope.basket.indexedItems[item.$id] = item;
      if (sync) {
        return this.model.addItem(item.$id, {
          'quantity': item.quantity
        });
      }
    };

    BasketModal.prototype._remove = function(item, sync) {
      if (sync == null) {
        sync = true;
      }
      this.scope.basket.items = _.without(this.scope.basket.items, item);
      delete this.scope.basket.indexedItems[item.$id];
      if (sync) {
        return this.model.removeItem(item.$id);
      }
    };

    BasketModal.prototype._syncItemsWithModel = function(store) {
      this.store = store;
      return this.model.$loaded((function(_this) {
        return function() {
          _this.resetBasket(false);
          if (_this.model.storeId) {
            return _this.model.onNewItem(function(itemId, item) {
              return _this.addItemById(itemId, item.quantity, false);
            });
          }
        };
      })(this));
    };

    return BasketModal;

  })();
  return BasketModal;
});

'use strict';

/**
  * @ngdoc service
  * @name denormalizedORM.baseModel
  * @description
  * # baseModel
  * Factory in the denormalizedORM.
 */
var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
  hasProp = {}.hasOwnProperty;

angular.module('denormalizedORM').factory('BaseModel', function($window, $q, $firebaseObject) {
  var BaseModel, ExtendedBaseModel;
  BaseModel = (function() {
    BaseModel.basePath = null;

    BaseModel.path = null;

    BaseModel.submodels = null;

    BaseModel.ref = function() {
      if (this.path == null) {
        throw new Error("Model.path must be defined");
      }
      if (this.basePath == null) {
        throw new Error("Model.basePath must be defined");
      }
      if (this._ref == null) {
        this._ref = new $window.Firebase(this.basePath + this.path);
      }
      return this._ref;
    };

    BaseModel.get = function(id, projection) {
      var ref;
      if (projection == null) {
        projection = ['profile'];
      }
      ref = this.projectRef(projection).child(id);
      return new this(ref);
    };

    BaseModel.create = function(attributes, id) {
      var baseRef, instance, promise, ref;
      if (attributes == null) {
        attributes = {};
      }
      if (id == null) {
        id = null;
      }
      baseRef = this.projectRef('all');
      if (id != null) {
        ref = baseRef.child(id);
      } else {
        ref = baseRef.push();
      }
      instance = new this(ref);
      promise = instance.$loaded().then(function() {
        _(instance).extend(attributes);
        return instance;
      });
      return promise;
    };

    function BaseModel(ref) {
      var result;
      result = $firebaseObject.call(this, ref);
      this.__buildLoadedPromise();
      return result;
    }

    BaseModel.projectRef = function(projection) {
      var attrData, attrKey, i, len, pathData, pathKey, paths, projectedRef, ref1, selectMap;
      if (projection == null) {
        projection = null;
      }
      if (projection === null || projection === 'all') {
        projection = (function() {
          var ref1, results;
          ref1 = this.submodels;
          results = [];
          for (pathKey in ref1) {
            if (!hasProp.call(ref1, pathKey)) continue;
            results.push(pathKey);
          }
          return results;
        }).call(this);
      }
      paths = (function() {
        var i, len, results;
        results = [];
        for (i = 0, len = projection.length; i < len; i++) {
          pathKey = projection[i];
          results.push(this.ref().child(pathKey));
        }
        return results;
      }).call(this);
      selectMap = [];
      for (i = 0, len = projection.length; i < len; i++) {
        pathKey = projection[i];
        pathData = this.submodels[pathKey];
        for (attrKey in pathData) {
          if (!hasProp.call(pathData, attrKey)) continue;
          attrData = pathData[attrKey];
          if (attrKey === "$value") {
            selectMap.push({
              'key': pathKey + "." + attrKey,
              'alias': pathKey
            });
          } else {
            selectMap.push(pathKey + "." + attrKey);
          }
        }
        selectMap.push({
          key: pathKey + ".updatedAt",
          alias: pathKey + "_updatedAt"
        });
        selectMap.push({
          key: pathKey + ".createdAt",
          alias: pathKey + "_createdAt"
        });
      }
      projectedRef = (ref1 = (function(func, args, ctor) {
        ctor.prototype = func.prototype;
        var child = new ctor, result = func.apply(child, args);
        return Object(result) === result ? result : child;
      })($window.Firebase.util.NormalizedCollection, paths, function(){})).select.apply(ref1, selectMap).ref();
      return projectedRef;
    };

    BaseModel.prototype.onUpdate = (function() {});

    BaseModel.prototype.onSave = (function() {});

    BaseModel.prototype.toJSON = function() {
      var result;
      result = {};
      this.forEach(function(value, key) {
        return result[key] = value;
      });
      return result;
    };

    BaseModel.prototype.$$updated = function(snap) {
      var changed;
      this.onUpdate();
      changed = $firebaseObject.prototype.$$updated.apply(this, arguments);
      return changed;
    };

    BaseModel.prototype.$save = function() {
      var pathKey, ref1;
      ref1 = this.constructor.submodels;
      for (pathKey in ref1) {
        if (!hasProp.call(ref1, pathKey)) continue;
        if (this[pathKey + "_createdAt"] == null) {
          this[pathKey + "_createdAt"] = $window.Firebase.ServerValue.TIMESTAMP;
        }
        this[pathKey + "_updatedAt"] = $window.Firebase.ServerValue.TIMESTAMP;
      }
      this.onSave();
      return $firebaseObject.prototype.$save.apply(this, arguments);
    };

    BaseModel.prototype.$loaded = function(resolve, reject) {
      var promise;
      promise = this._loadedPromise;
      if (arguments.length) {
        promise = promise.then.call(promise, resolve, reject);
      }
      return promise;
    };

    BaseModel.prototype.$OnChanged = function(callback) {
      var $watchUnwatch, unwatch, unwatched;
      unwatched = false;
      $watchUnwatch = this.$watch((function(_this) {
        return function() {
          return callback(_this);
        };
      })(this));
      this.$loaded().then((function(_this) {
        return function() {
          return callback(indexOf.call(!unwatched, _this) >= 0);
        };
      })(this));
      unwatch = function() {
        $watchUnwatch();
        return unwatched = true;
      };
      return unwatch;
    };

    BaseModel._ref = null;

    BaseModel.prototype._loadedPromise = null;

    BaseModel.prototype.__buildLoadedPromise = function() {
      var deferred, loadedPromise, promise, unwatch;
      deferred = $q.defer();
      unwatch = this.$watch((function(_this) {
        return function() {
          return deferred.resolve(_this);
        };
      })(this));
      loadedPromise = $firebaseObject.prototype.$loaded.apply(this);
      loadedPromise.then((function(_this) {
        return function() {
          return deferred.resolve(_this);
        };
      })(this))["catch"]((function(_this) {
        return function(error) {
          return deferred.reject(error);
        };
      })(this));
      promise = deferred.promise.then(function(self) {
        unwatch();
        return self;
      });
      return this._loadedPromise = promise;
    };

    return BaseModel;

  })();
  ExtendedBaseModel = $firebaseObject.$extend(BaseModel);
  return ExtendedBaseModel;
}).factory('BaseModelList', function($window, $firebaseArray, $http, $q, $timeout) {
  var BaseModelList, ExtendedBaseList;
  BaseModelList = (function() {
    var page, scroll;

    BaseModelList.Model = null;

    BaseModelList.onNewIntancesCallbacks = null;

    BaseModelList.onIntancesRemovedCallbacks = null;

    scroll = null;

    page = null;

    BaseModelList.one = function(id, projection) {
      this.__checkModel();
      return this.Model.get(id, projection);
    };

    BaseModelList.all = function(projection, options) {
      var query;
      if (projection == null) {
        projection = ['profile'];
      }
      if (options == null) {
        options = {};
      }
      this.__checkModel();
      query = this.Model.projectRef(projection);
      if (_(options.limit).isNumber()) {
        query = query.limitToFirst(options.limit);
      }
      return new this(query);
    };

    BaseModelList.allKeys = function(update) {
      var profilePath, promise, url;
      if (update == null) {
        update = true;
      }
      this.__checkModel();
      profilePath = 'profile';
      url = (this.Model.basePath + this.Model.path) + "/" + profilePath;
      promise = $http.get(url + '.json', {
        'params': {
          'shallow': true
        },
        'responseType': 'text',
        'transformResponse': [
          function(data) {
            return data;
          }
        ]
      });
      return promise.then((function(_this) {
        return function(response) {
          var keysArray, match, rawData, re;
          re = /\"([^\"]+)\"/g;
          rawData = response.data;
          keysArray = [];
          while (match = re.exec(rawData)) {
            keysArray.push(match[1]);
          }
          keysArray.sort(function(a, b) {
            var aS, bS;
            aS = a[0] === '-';
            bS = b[0] === '-';
            if (aS !== bS) {
              if (aS) {
                return -1;
              } else {
                return 1;
              }
            } else if (a > b) {
              return -1;
            } else if (a === b) {
              return 0;
            } else {
              return 1;
            }
          });
          if (update) {
            _this.onNewIntance(function(instance, key) {
              return keysArray.unshift(key);
            }, false);
            _this.onIntanceRemoved(function(instance, key) {
              var intanceIndex;
              intanceIndex = keysArray.indexOf(key);
              if (~intanceIndex) {
                return keysArray.splice(intanceIndex, 1);
              }
            });
          }
          return keysArray;
        };
      })(this));
    };

    BaseModelList.onNewIntance = function(callback, instantiate) {
      var path, profilePath, ref;
      if (instantiate == null) {
        instantiate = true;
      }
      if (this.onNewIntancesCallbacks == null) {
        this.onNewIntancesCallbacks = [];
        profilePath = 'profile';
        path = (this.Model.basePath + this.Model.path) + "/" + profilePath;
        ref = new $window.Firebase(path);
        ref.orderByChild('createdAt').startAt(Date.now()).on("child_added", (function(_this) {
          return function(snapshot) {
            var instance, key, rawInstance;
            instance = null;
            rawInstance = null;
            key = snapshot.key();
            return _(_this.onNewIntancesCallbacks).each(function(command) {
              if (command.instantiate) {
                if (instance == null) {
                  instance = new _this(snapshot.ref());
                }
                return instance.$loaded().then(function() {
                  return callback(instance, key, snapshot);
                });
              } else {
                if (rawInstance == null) {
                  rawInstance = snapshot.val();
                }
                return callback(rawInstance, key, snapshot);
              }
            });
          };
        })(this));
      }
      this.onNewIntancesCallbacks.push({
        'callback': callback,
        'instantiate': instantiate
      });
    };

    BaseModelList.onIntanceRemoved = function(callback) {
      var path, profilePath, ref;
      if (this.onIntancesRemovedCallbacks == null) {
        this.onIntancesRemovedCallbacks = [];
        profilePath = 'profile';
        path = (this.Model.basePath + this.Model.path) + "/" + profilePath;
        ref = new $window.Firebase(path);
        ref.on("child_removed", (function(_this) {
          return function(snapshot) {
            var key;
            key = snapshot.key();
            return _(_this.onIntancesRemovedCallbacks).each(function(command) {
              return callback(snapshot.val(), key, snapshot);
            });
          };
        })(this));
      }
      this.onIntancesRemovedCallbacks.push({
        'callback': callback
      });
    };

    function BaseModelList(ref) {
      var result;
      this.constructor.__checkModel();
      result = $firebaseArray.call(this, ref);
      if (ref.scroll != null) {
        result.scroll = ref.scroll;
      }
      if (ref.page != null) {
        result.page = ref.page;
        result.page.setOptions = this.constructor._setPageOptions;
      }
      return result;
    }

    BaseModelList.allScroll = function(projection, options, orderBy) {
      var query, result, scrollRef;
      if (projection == null) {
        projection = ['profile'];
      }
      if (options == null) {
        options = {
          pageSize: 20
        };
      }
      if (orderBy == null) {
        orderBy = 'createdAt';
      }
      query = this.Model.ref().child('profile');
      scrollRef = new $window.Firebase.util.Scroll(query, orderBy, options);
      result = new this(scrollRef);
      return result;
    };

    BaseModelList.allPaginate = function(projection, options, orderBy) {
      var paginatedRef, query, result;
      if (projection == null) {
        projection = ['profile'];
      }
      if (options == null) {
        options = {
          pageSize: 20
        };
      }
      if (orderBy == null) {
        orderBy = 'createdAt';
      }
      query = this.Model.ref().child('profile');
      if (options.maxCacheSize == null) {
        options.maxCacheSize = options.pageSize * 7;
      }
      paginatedRef = new $window.Firebase.util.Paginate(query, orderBy, options);
      result = new this(paginatedRef);
      return result;
    };

    BaseModelList.prototype.$OnChanged = function(callback) {
      var $watchUnwatch, unwatch, unwatched;
      unwatched = false;
      $watchUnwatch = this.$watch((function(_this) {
        return function() {
          return callback(_this);
        };
      })(this));
      this.$loaded().then((function(_this) {
        return function() {
          return callback(indexOf.call(!unwatched, _this) >= 0);
        };
      })(this));
      unwatch = function() {
        $watchUnwatch();
        return unwatched = true;
      };
      return unwatch;
    };

    BaseModelList._setPageOptions = function(options) {
      var Cache;
      if (this.cache == null) {
        throw new Exception("Sorry, I need a cache instance to set the options.");
      }
      Cache = this.cache.constructor;
      if (options.pageSize != null) {
        this.pageSize = options.pageSize;
      }
      if (options.maxCacheSize != null) {
        this.max = options.maxCacheSize;
        this.cache._removeOrphans({
          hasChild: function() {
            return false;
          }
        });
        this.cache.destroy();
        this.cache = new Cache(this.ref, this.field, options.maxCacheSize);
        this.cache.observeHasNext(this._countPages, this);
        return this.currPage = 0;
      }
    };

    BaseModelList.__checkModel = function() {
      if (this.Model == null) {
        throw new Error("Model must be set for every BaseModelList subclass.");
      }
    };

    BaseModelList.prototype.$$added = function(snap) {
      var instance;
      this.constructor.__checkModel();
      instance = new this.constructor.Model(snap.ref());
      return instance.$loaded();
    };

    BaseModelList.prototype.$destroy = function() {
      if (this.page != null) {
        console.log("Page destroyed");
        page.destroy();
      }
      if (this.scroll != null) {
        scroll.destroy();
      }
      return $firebaseArray.prototype.$destroy.apply(this, arguments);
    };

    return BaseModelList;

  })();
  ExtendedBaseList = $firebaseArray.$extend(BaseModelList);
  return ExtendedBaseList;
});

'use strict';

/**
  * @ngdoc service
  * @name denormalizedORM.BaseSimpleModel
  * @description
  * # BaseSimpleModel
  * Factory in the denormalizedORM.
 */
angular.module('denormalizedORM').factory('BaseSimpleModel', function($window, $q, $firebaseObject) {
  var BaseSimpleModel, ExtendedBaseSimpleModel;
  BaseSimpleModel = (function() {
    BaseSimpleModel.basePath = null;

    BaseSimpleModel.path = null;

    BaseSimpleModel.ref = function() {
      if (this.path == null) {
        throw new Error("Model.path must be defined");
      }
      if (this.basePath == null) {
        throw new Error("Model.basePath must be defined");
      }
      if (this._ref == null) {
        this._ref = new $window.Firebase(this.basePath + this.path);
      }
      return this._ref;
    };

    BaseSimpleModel.get = function(id) {
      var ref;
      ref = this.ref().child(id);
      return new this(ref);
    };

    BaseSimpleModel.create = function(attributes, id) {
      var instance, promise, ref;
      if (attributes == null) {
        attributes = {};
      }
      if (id == null) {
        id = null;
      }
      if (id != null) {
        ref = this.ref().child(id);
      } else {
        ref = this.ref().push();
      }
      instance = new this(ref);
      promise = instance.$loaded().then(function() {
        _(instance).extend(attributes);
        return instance;
      });
      return promise;
    };

    function BaseSimpleModel(ref) {
      var result;
      result = $firebaseObject.call(this, ref);
      this.__buildLoadedPromise();
      return result;
    }

    BaseSimpleModel.prototype.onUpdate = (function() {});

    BaseSimpleModel.prototype.onSave = (function() {});

    BaseSimpleModel.prototype.toJSON = function() {
      var result;
      result = {};
      this.forEach(function(value, key) {
        return result[key] = value;
      });
      return result;
    };

    BaseSimpleModel.prototype.$$updated = function(orderSnapshot) {
      var changed;
      this.onUpdate();
      changed = $firebaseObject.prototype.$$updated.apply(this, arguments);
      return changed;
    };

    BaseSimpleModel.prototype.$save = function() {
      if (this.createdAt == null) {
        this.createdAt = $window.Firebase.ServerValue.TIMESTAMP;
      }
      this.updatedAt = $window.Firebase.ServerValue.TIMESTAMP;
      this.onSave();
      return $firebaseObject.prototype.$save.apply(this, arguments);
    };

    BaseSimpleModel.prototype.$loaded = function(resolve, reject) {
      var promise;
      promise = this._loadedPromise;
      if (arguments.length) {
        promise = promise.then.call(promise, resolve, reject);
      }
      return promise;
    };

    BaseSimpleModel._ref = null;

    BaseSimpleModel.prototype._loadedPromise = null;

    BaseSimpleModel.prototype.__buildLoadedPromise = function() {
      var deferred, loadedPromise, promise, unwatch;
      deferred = $q.defer();
      unwatch = this.$watch((function(_this) {
        return function() {
          return deferred.resolve(_this);
        };
      })(this));
      loadedPromise = $firebaseObject.prototype.$loaded.apply(this);
      loadedPromise.then((function(_this) {
        return function() {
          return deferred.resolve(_this);
        };
      })(this))["catch"]((function(_this) {
        return function(error) {
          return deferred.reject(error);
        };
      })(this));
      promise = deferred.promise.then(function(self) {
        unwatch();
        return self;
      });
      return this._loadedPromise = promise;
    };

    return BaseSimpleModel;

  })();
  ExtendedBaseSimpleModel = $firebaseObject.$extend(BaseSimpleModel);
  return ExtendedBaseSimpleModel;
}).factory('BaseSimpleModelList', function($window, $firebaseArray, $http) {
  var BaseSimpleModelList, ExtendedBaseList;
  BaseSimpleModelList = (function() {
    BaseSimpleModelList.Model = null;

    BaseSimpleModelList.one = function(id) {
      this.__checkModel();
      return this.Model.get(id);
    };

    BaseSimpleModelList.all = function(options) {
      var query;
      if (options == null) {
        options = {};
      }
      this.__checkModel();
      query = this.Model.ref();
      if (_(options.limit).isNumber()) {
        query = query.limitToFirst(options.limit);
      }
      return new this(query);
    };

    BaseSimpleModelList.allKeys = function() {
      var promise, url;
      this.__checkModel();
      url = (this.Model.basePath + this.Model.path) + "/.json";
      promise = $http.get(url, {
        'params': {
          'shallow': true
        },
        'responseType': 'text',
        'transformResponse': [
          function(data) {
            return data;
          }
        ]
      });
      return promise.then(function(response) {
        var keysArray, match, rawData, re;
        re = /\"([^\"]+)\"/g;
        rawData = response.data;
        keysArray = [];
        while (match = re.exec(rawData)) {
          keysArray.push(match[1]);
        }
        keysArray.sort(function(a, b) {
          var aS, bS;
          aS = a[0] === '-';
          bS = b[0] === '-';
          if (aS !== bS) {
            if (aS) {
              return -1;
            } else {
              return 1;
            }
          } else if (a > b) {
            return -1;
          } else if (a === b) {
            return 0;
          } else {
            return 1;
          }
        });
        return keysArray;
      });
    };

    function BaseSimpleModelList(ref) {
      var result;
      this.constructor.__checkModel();
      result = $firebaseArray.call(this, ref);
      return result;
    }

    BaseSimpleModelList.prototype.$$added = function(snap) {
      var instance;
      this.constructor.__checkModel();
      instance = new this.constructor.Model(snap.ref());
      return instance.$loaded();
    };

    BaseSimpleModelList.__checkModel = function() {
      if (this.Model == null) {
        throw new Error("Model must be set for every BaseSimpleModelList subclass.");
      }
    };

    BaseSimpleModelList.prototype.$destroy = function() {
      return $firebaseArray.prototype.$destroy.apply(this, arguments);
    };

    return BaseSimpleModelList;

  })();
  ExtendedBaseList = $firebaseArray.$extend(BaseSimpleModelList);
  return ExtendedBaseList;
});

angular.module('denormalizedORM', []).config((function() {}));

angular.module('kronoapp.device.services', ['PubSub']).factory('Device', function(_, PubSub, $ionicPlatform, $window, $q, $timeout, $cordovaPushV5, $http, $ionicPopup, $localStorage, User, PARSE_APP_ID, PARSE_REST_KEY, SENDER_ID) {
  return {
    notificationChannel: 'device:notificationReceived',
    tokenReceivedChannel: 'device:tokenReceived',
    areNotificationsEnabled: function() {
      var q;
      q = $q.defer();
      $ionicPlatform.ready((function(_this) {
        return function() {
          if (_this.deviceType === 'ios') {
            if ($window.pushNotification != null) {
              return $window.pushNotification.areNotificationsEnabled((function(isRegistered) {
                console.log("Notifications " + isRegistered);
                if (isRegistered) {
                  return q.resolve();
                } else {
                  return q.reject();
                }
              }), function(error) {
                console.error("Push Notifications Error: " + error);
                return q.reject(error);
              });
            } else {
              return q.reject();
            }
          } else {
            return q.resolve();
          }
        };
      })(this));
      return q.promise;
    },
    onNotification: function(listener) {
      return PubSub.subscribe(this.notificationChannel, function(e, data) {
        return listener(data);
      });
    },
    onTokenReceived: function(listener) {
      return PubSub.subscribe(this.tokenReceivedChannel, function(e, data) {
        return listener(data);
      });
    },
    isRegistered: function() {
      return this.getDeviceId() != null;
    },
    subscribeToChannels: function(channels) {
      if (channels == null) {
        channels = [];
      }
      if (this.getDeviceId() == null) {
        return this.initializeNotifications(channels);
      } else {
        return this._updateDevice({
          'channels': {
            '__op': 'AddUnique',
            'objects': channels
          }
        }, PARSE_APP_ID, PARSE_REST_KEY);
      }
    },
    initializeNotifications: function(channels, AppId, APIKey, senderId) {
      if (channels == null) {
        channels = [''];
      }
      if (AppId == null) {
        AppId = PARSE_APP_ID;
      }
      if (APIKey == null) {
        APIKey = PARSE_REST_KEY;
      }
      if (senderId == null) {
        senderId = SENDER_ID;
      }
      $ionicPlatform.ready((function(_this) {
        return function() {
          var config, deviceType;
          if ($window.PushNotification != null) {
            deviceType = _this.deviceType();
            config = {
              'android': {
                'senderID': senderId
              },
              'ios': {
                'sound': true,
                'vibrate': true,
                'badge': true
              }
            };
            $cordovaPushV5.register(config).then((function(deviceToken) {
              console.log("Device registered for notifications\n Device Token: " + deviceToken);
              _this._registerDevice(deviceToken, AppId, APIKey, channels, deviceType);
              return PubSub.publish(_this.tokenReceivedChannel, deviceToken);
            }), function(err) {
              return console.error("Push Notifications Error: " + err);
            });
            return $rootScope.$on('$cordovaPushV5:notificationReceived', function(event, notification) {
              console.log("JSON Notification:\n " + (JSON.stringify(notification, null, 4)) + "\n");
              switch (deviceType) {
                case 'android':
                  return _this._handleAndroidNotification(event, notification);
                case 'ios':
                  return _this._handleIOSNotification(event, notification);
              }
            });
          }
        };
      })(this));
      $window.receiveIOSNotification = (function(_this) {
        return function(notification) {
          return _this._handleIOSNotification({}, notification);
        };
      })(this);
      return $window.receiveAndroidNotification = (function(_this) {
        return function(notification, event) {
          if (event == null) {
            event = 'message';
          }
          return _this._handleAndroidNotification({}, notification, AppId, APIKey, channels);
        };
      })(this);
    },
    registerForUser: function(user, AppId, APIKey) {
      if (AppId == null) {
        AppId = PARSE_APP_ID;
      }
      if (APIKey == null) {
        APIKey = PARSE_REST_KEY;
      }
      if (user) {
        return this._updateDevice({
          'ownerId': user._id
        }, AppId, APIKey);
      }
    },
    deviceType: function() {
      if (ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
        return 'ios';
      } else {
        return 'android';
      }
    },
    setDeviceToken: function(token) {
      this._deviceToken = token;
      $localStorage['device:token'] = this._deviceToken;
      return console.log("Setting Device Token " + this._deviceToken);
    },
    getDeviceToken: function() {
      if (this._deviceToken == null) {
        this._deviceToken = $localStorage['device:token'];
      }
      console.log("Device token " + this._deviceToken);
      return this._deviceToken;
    },
    setDeviceId: function(id) {
      this._deviceId = id;
      return $localStorage['device:id'] = this._deviceId;
    },
    getDeviceId: function() {
      if (this._deviceId == null) {
        this._deviceId = $localStorage['device:id'];
      }
      return this._deviceId;
    },
    _deviceId: null,
    _deviceToken: null,
    _registerDevice: function(deviceToken, APP_ID, API_KEY, channels, deviceType) {
      if (deviceType == null) {
        deviceType = 'android';
      }
      if (deviceToken != null) {
        this.setDeviceToken(deviceToken);
      }
      if (this.getDeviceId() == null) {
        return this.__registerDevice(deviceToken, APP_ID, API_KEY, channels, deviceType);
      } else {
        return $http({
          method: 'PUT',
          url: "https://api.parse.com/1/installations/" + (this.getDeviceId()),
          headers: {
            'X-Parse-Application-Id': APP_ID,
            'X-Parse-Client-Key': API_KEY,
            'Content-Type': 'application/json'
          },
          data: {}
        }).success(function(data, status, headers, config) {
          return console.log('Device already registered');
        }).error((function(_this) {
          return function(data, status, headers, config) {
            if (status === 404) {
              _this.__registerDevice(deviceToken, APP_ID, API_KEY, channels, deviceType);
              return console.error("Local DeviceId:" + (_this.getDeviceId()) + " not found on the server");
            } else {
              return console.log("Device._updateDevice Error " + JSON.stringify([data, status, headers], null, 4));
            }
          };
        })(this));
      }
    },
    __registerDevice: function(deviceToken, APP_ID, API_KEY, channels, deviceType) {
      var data;
      data = {
        'deviceType': deviceType,
        'deviceToken': deviceToken,
        'channels': channels
      };
      switch (deviceType) {
        case 'android':
          _(data).extend({
            'pushType': 'gcm'
          });
      }
      console.log("Registering Device for notifications: " + JSON.stringify(data, null, 4));
      return $http({
        method: 'POST',
        url: 'https://api.parse.com/1/installations',
        headers: {
          'X-Parse-Application-Id': APP_ID,
          'X-Parse-Client-Key': API_KEY,
          'Content-Type': 'application/json'
        },
        data: data
      }).success((function(_this) {
        return function(response, status, headers, config) {
          console.log("Device._registerDevice Success " + JSON.stringify(response, null, 4));
          return _this.setDeviceId(response.objectId);
        };
      })(this)).error(function(response, status, headers, config) {
        return console.log("Device._registerDevice Error " + JSON.stringify([response, status, headers], null, 4));
      });
    },
    _updateDevice: function(data, APP_ID, API_KEY) {
      _(data).defaults({});
      console.log("Updating Device: " + JSON.stringify(data, null, 4));
      return $http({
        method: 'PUT',
        url: "https://api.parse.com/1/installations/" + (this.getDeviceId()),
        headers: {
          'X-Parse-Application-Id': APP_ID,
          'X-Parse-Client-Key': API_KEY,
          'Content-Type': 'application/json'
        },
        data: data
      }).success(function(data, status, headers, config) {
        return console.log("Device._updateDevice Success " + JSON.stringify(data, null, 4));
      }).error(function(data, status, headers, config) {
        return console.log("Device._updateDevice Error " + JSON.stringify([data, status, headers], null, 4));
      });
    },
    _handleIOSNotification: function(event, notification) {
      var snd;
      if (notification.additionalData != null) {
        notification.pushId = notification.additionalData.pushId;
      }
      if (notification.alert) {
        notification.message = notification.alert;
      }
      if (notification.sound) {
        snd = new Media(event.sound);
        snd.play();
      }
      if (notification.badge) {
        $cordovaPushV5.setBadgeNumber(notification.badge).then((function(result) {}), function(err) {
          return console.error("Error setting badge: " + err);
        });
      }
      return PubSub.publish(this.notificationChannel, notification);
    },
    _handleAndroidNotification: function(event, notification) {
      if (notification.additionalData != null) {
        notification.pushId = notification.additionalData.pushId;
      }
      return PubSub.publish(this.notificationChannel, notification);
    }
  };
});

angular.module('kronoapp.home.controllers', []).controller('HomeCtrl', function(_, l, $rootScope, $scope, $state, $ionicPopup, $localStorage, $ionicHistory, $analytics, $ionicPlatform, $cordovaGeolocation, Stores, basketModal, Basket, $timeout, Feedback, SINGLE_STORE_ID) {
  var queryGeolocation, reset, sendFeedback, unwatchStores, updateGeolocation;
  $analytics.eventTrack('Page View', {
    'page': 'Home'
  });
  $scope.stores = Stores.all(['profile']);
  $scope.sortChainsByGeolocation = function() {
    if ($scope.position.status === 'OK' && ($scope.chains != null)) {
      _($scope.chains).each(function(chain) {
        var lowerDistance;
        lowerDistance = Number.MAX_VALUE;
        _(chain.stores).each(function(store) {
          var distance;
          distance = store.calculateDistance($scope.position);
          return lowerDistance = Math.min(distance, lowerDistance);
        });
        chain.stores.sort(function(a, b) {
          return a.distance - b.distance;
        });
        return chain.distance = lowerDistance;
      });
      return $scope.chains.sort(function(a, b) {
        return a.distance - b.distance;
      });
    }
  };
  $scope.chainHasBasket = function(chain) {
    var basket;
    basket = $scope.basket;
    return _(chain.stores).some(function(store) {
      return basket.containsProductsOf(store);
    });
  };
  $scope.openChainStores = function(chain) {
    if (chain.stores.length === 1) {
      return $scope.enterInStore(chain.stores[0]);
    } else {
      return chain.open = !chain.open;
    }
  };
  $scope.priceDisclaimer = function() {
    var counter;
    $scope.existPriceDisclaimer = true;
    counter = $localStorage['priceDisclaimer'];
    if (!(counter != null)) {
      return $localStorage['priceDisclaimer'] = 1;
    } else {
      if ($localStorage['priceDisclaimer'] <= 19) {
        return $localStorage['priceDisclaimer'] += 1;
      } else {
        return $scope.existPriceDisclaimer = false;
      }
    }
  };
  $scope.user = $rootScope.user;
  reset = function() {
    return $scope.feedbackForm = {
      feedback: {
        userId: null,
        text: ''
      },
      error: null
    };
  };
  reset();
  sendFeedback = function() {
    if (!$scope.feedbackForm.error) {
      $scope.feedbackForm.sending = true;
      return Feedback.create($scope.feedbackForm.feedback).$loaded()["finally"](function() {
        reset();
        $scope.popup1.close();
        $ionicPopup.alert({
          title: l('%global.message'),
          template: l('%feedback.sended')
        });
        return $scope.feedbackForm.sending = false;
      });
    }
  };
  $scope.sendSuggestion = function() {
    var name;
    if ($scope.user) {
      $scope.feedbackForm.feedback.userId = $scope.user._id;
    }
    $analytics.eventTrack('Feedback sent', {
      context: 'stores list'
    });
    if ($scope.feedbackForm.feedback.text.length === 0) {
      $scope.feedbackForm.error = l('%stores.suggestion.error');
    } else {
      $scope.feedbackForm.error = null;
    }
    if (!$scope.feedbackForm.feedback.userId) {
      name = $localStorage['user-feedback-email'];
      if (name == null) {
        return $scope.popup1 = $ionicPopup.show({
          title: l('%global.confirm'),
          subTitle: l('%stores.suggestion.user_email'),
          template: '<input type="email" ng-model="feedbackForm.feedback.name">',
          scope: $scope,
          buttons: [
            {
              text: l('%feedback.submit'),
              type: 'button-positive',
              onTap: (function(_this) {
                return function() {
                  name = $scope.feedbackForm.feedback.name;
                  $localStorage['user-feedback-email'] = name;
                  $scope.popup1.close();
                  return sendFeedback();
                };
              })(this)
            }
          ]
        });
      } else {
        $scope.feedbackForm.feedback.name = name;
        return sendFeedback();
      }
    } else {
      return sendFeedback();
    }
  };
  $scope.position = {
    'lat': 0,
    'lon': 0,
    'status': 'LOADING'
  };
  queryGeolocation = function(timeout, enableHighAccuracy, maximumAge) {
    var geoTime;
    if (timeout == null) {
      timeout = 5000;
    }
    if (enableHighAccuracy == null) {
      enableHighAccuracy = false;
    }
    if (maximumAge == null) {
      maximumAge = 900000;
    }
    console.log("Quering geolocation");
    geoTime = Date.now();
    return $ionicPlatform.ready(function() {
      return $cordovaGeolocation.getCurrentPosition({
        'timeout': timeout,
        'enableHighAccuracy': enableHighAccuracy,
        'maximumAge': maximumAge
      }).then(function(position) {
        geoTime = Date.now() - geoTime;
        console.log("Got geolocation in " + (geoTime / 1000) + " secs:\n " + (JSON.stringify(position)));
        $scope.position = {
          'lat': position.coords.latitude,
          'lon': position.coords.longitude,
          'status': 'OK'
        };
        return $scope.sortChainsByGeolocation();
      }, function(err) {
        var retryTime;
        console.error("Error with geolocation " + (JSON.stringify(err)));
        if ($scope.position.status !== 'OK') {
          $scope.position.status = 'TIMED_OUT';
        }
        retryTime = err.code === 1 ? 6000 : 3000;
        return $timeout((function() {
          return queryGeolocation(timeout, enableHighAccuracy, maximumAge);
        }), retryTime);
      });
    });
  };
  updateGeolocation = null;
  $scope.$on('$ionicView.beforeEnter', function() {
    if (SINGLE_STORE_ID !== null) {
      $ionicHistory.nextViewOptions({
        disableBack: true
      });
      return $state.go('app.store-lobby', {
        storeId: SINGLE_STORE_ID
      });
    }
  });
  $scope.$on('$ionicView.afterEnter', function() {
    queryGeolocation();
    return queryGeolocation(30000);
  });
  $scope.welcomeTutorial.openOnce();
  $scope.priceDisclaimer();
  unwatchStores = $scope.stores.$OnChanged(function() {
    $scope.chains = _($scope.stores).chain().filter(function(store) {
      return store.isActive;
    }).groupBy(function(store) {
      return store.chainId || store.name;
    }).map(function(stores, chainName) {
      return {
        'name': chainName,
        'open': false,
        'stores': stores
      };
    }).value();
    return $scope.sortChainsByGeolocation();
  });
  $scope.$on('$ionicView.leave', function() {
    return unwatchStores();
  });
  return $scope.enterInStore = function(store) {
    return $scope.basket.$loaded(function() {
      $analytics.eventTrack('Enter in Store', {
        'store': store.name
      });
      if ($scope.basket.containsProductsOfOtherThan(store)) {
        return $ionicPopup.confirm({
          title: l('%global.confirm'),
          template: l('%stores.actions.erase_basket'),
          cancelText: l('%global.no'),
          okText: l('%global.yes')
        }).then(function(confirmed) {
          if (confirmed) {
            return $state.go('app.store-lobby', {
              storeId: store._id
            });
          }
        });
      } else {
        return $state.go('app.store-lobby', {
          storeId: store._id
        });
      }
    });
  };
});

angular.module('kronoapp.orders.controllers', []).controller('OrdersCtrl', function(_, l, $scope, $state, $analytics, Orders, $timeout) {
  var calculateArrays;
  $analytics.eventTrack('Page View', {
    'page': 'My Orders'
  });
  calculateArrays = function() {
    var groups, orders;
    orders = $scope.orders;
    groups = _(orders).chain().filter(function(o) {
      return o.status;
    }).groupBy(function(order) {
      return order.isCurrent();
    }).value();
    $scope.currentOrders = groups[true];
    return $scope.pastOrders = groups[false];
  };
  $scope.orders.$loaded(calculateArrays);
  return $scope.orders.$watch(calculateArrays);
}).controller('OrderDetailCtrl', function(_, l, $scope, $state, $stateParams, $ionicPopup, $analytics, $q, Orders, StockItem) {
  var _addOrderToBasket;
  $scope.order = Orders.get($stateParams.orderId);
  $scope.total = '';
  $scope.order.$loaded().then(function(order) {
    $scope.store = order.store();
    $scope.total = 0;
    _(order.items).each(function(item) {
      $scope.total += item.price * item.quantity;
      item.stockItem = StockItem.get(item.stockItemId);
      return item;
    });
    return $analytics.eventTrack('Page View', {
      'page': 'Order Details',
      'store': $scope.store.name
    });
  });
  $scope.showAddOrderToBasket = function() {
    return $scope.order != null;
  };
  $scope.addOrderToBasket = function() {
    return $scope.basket.$loaded(function() {
      $analytics.eventTrack('Add Order to Basket', {
        'store': $scope.store.name
      });
      if ($scope.basket.containsProductsOfOtherThan($scope.store)) {
        return $ionicPopup.confirm({
          title: l('%global.confirm'),
          template: l('%order-detail.actions.erase_basket_confirm'),
          cancelText: l('%global.no'),
          okText: l('%global.yes')
        }).then(function(confirmed) {
          if (confirmed) {
            return _addOrderToBasket();
          }
        });
      } else if ($scope.basket.containsProductsOf($scope.store)) {
        return $ionicPopup.confirm({
          title: l('%global.confirm'),
          template: l('%order-detail.actions.add_to_basket_confirm'),
          cancelText: l('%global.no'),
          okText: l('%global.yes')
        }).then(function(confirmed) {
          if (confirmed) {
            return _addOrderToBasket();
          }
        });
      } else {
        return _addOrderToBasket();
      }
    });
  };
  return _addOrderToBasket = function() {
    var items_with_errors, promises;
    $scope.basketModal.setStore($scope.store);
    items_with_errors = [];
    promises = _($scope.order.items).map(function(item) {
      var stockItemId;
      stockItemId = item.stockItemId;
      return $scope.basketModal.addItemById(item.stockItemId, item.quantity)["catch"](function(error) {
        items_with_errors.push(item);
        return $q.reject(error);
      });
    });
    return $q.all(promises).then(function(r) {
      $state.go('app.store-lobby', {
        storeId: $scope.store._id
      });
      return $scope.basketModal.open();
    }, function(errors) {
      console.log(errors);
      return alert(l('%order-detail.add_to_basket_error'));
    });
  };
});

var app;

app = angular.module("kronoapp.orders.directives", []);

app.directive('orderItem', function(Store) {
  return {
    restrict: 'A',
    scope: {
      order: '=orderItem',
      stores: '=stores'
    },
    templateUrl: 'templates/orders/item.html',
    link: function(scope, element, attrs) {
      return scope.store = scope.order.store();
    }
  };
}).directive('orderShortcut', function(l, $ionicPopup, $interval) {
  return {
    restrict: 'A',
    scope: {
      order: '=orderShortcut',
      stores: '=stores'
    },
    templateUrl: 'templates/orders/item_shortcut.html',
    link: function(scope, element, attrs) {
      var canSendAlertInterval, checkSendInterval;
      scope.store = scope.order.store();
      checkSendInterval = function() {
        return scope.canSendAlert = scope.order.canSendArrivalAlert();
      };
      canSendAlertInterval = $interval(checkSendInterval, 1000);
      checkSendInterval();
      scope.$on('$destroy', function() {
        return $interval.cancel(canSendAlertInterval);
      });
      element.bind('click', function() {
        return scope.sendArrivalAlert();
      });
      return scope.sendArrivalAlert = function() {
        if (scope.canSendAlert) {
          return $ionicPopup.confirm({
            title: l('%global.confirm'),
            template: l('%orders.actions.send_arrival_alert.confirm'),
            cancelText: l('%global.no'),
            okText: l('%global.yes')
          }).then(function(confirmed) {
            if (confirmed) {
              return scope.order.sendArrivalAlert().then(checkSendInterval);
            }
          });
        }
      };
    }
  };
});

angular.module('kronoapp.orders.services', []).factory('Orders', function(_, $firebaseObject, $firebaseArray, $q, FirebaseRef, Store) {
  var Order, OrderIndexList, mainRef, minutesToAllowResendAlert, ordersRef, pendingStatiList;
  mainRef = FirebaseRef.get();
  ordersRef = mainRef.child('orders');
  minutesToAllowResendAlert = 3;
  Order = $firebaseObject.$extend({
    $_store: null,
    $$updated: function(orderSnapshot) {
      var changed;
      this._id = this.$id;
      changed = $firebaseObject.prototype.$$updated.apply(this, arguments);
      return changed;
    },
    isCurrent: function() {
      return _(pendingStatiList).contains(this.status);
    },
    isReady: function() {
      return this.status === Order.stati.Ready;
    },
    store: function() {
      if (!this.$_store) {
        this.$_store = Store.get(this.storeId);
      }
      return this.$_store;
    },
    canSendArrivalAlert: function() {
      var timeToResend;
      timeToResend = minutesToAllowResendAlert * 60 * 1000;
      return this.isReady() && (this.clientArrived || 0) < Date.now() - timeToResend;
    },
    sendArrivalAlert: function() {
      var deferred;
      deferred = $q.defer();
      this.$ref().child('clientArrived').set(FirebaseRef.TIMESTAMP, function(error) {
        if (error) {
          return deferred.reject(error);
        }
        return deferred.resolve();
      });
      return deferred.promise;
    }
  });
  Order.get = function(id) {
    return new Order(ordersRef.child(id));
  };
  Order.create = function(data) {
    if (data == null) {
      data = void 0;
    }
    return new Order(ordersRef.push(data));
  };
  OrderIndexList = $firebaseArray.$extend({
    __objUnwatchers: {},
    $$added: function(orderSnapshot) {
      var key, order;
      key = orderSnapshot.key();
      order = new Order(ordersRef.child(key));
      this.__objUnwatchers[key] = order.$watch((function(_this) {
        return function() {
          return _this.$$notify('child_changed', key);
        };
      })(this));
      return order;
    },
    $$removed: function(orderSnapshot) {
      var key;
      key = orderSnapshot.key();
      return this.__objUnwatchers[key]();
    }
  });
  Order.allFromUser = function(user) {
    return new OrderIndexList(user.ordersRef());
  };
  Order.placeOrder = function(data) {
    var order, order_data;
    order_data = _(data).mapObject(function(val, key) {
      return val || {};
    });
    order_data.createdAt = FirebaseRef.TIMESTAMP;
    order = Order.create(order_data);
    return order;
  };
  Order.stati = {
    Requested: 'REQUESTED',
    Processing: 'PROCESSING',
    Ready: 'READY',
    Delivered: 'DELIVERED',
    Canceled: 'CANCELED'
  };
  Order.deliveryOptions = {
    Pickup: 'PICKUP',
    Domicile: 'DOMICILE'
  };
  Order.paymentOptions = {
    Cash: 'CASH',
    Card: 'CARD',
    Online: 'ONLINE'
  };
  pendingStatiList = [Order.stati.Requested, Order.stati.Processing, Order.stati.Ready];
  return Order;
});

var app;

app = angular.module('kronoapp.products.directives', []);

app.directive('stockItem', function() {
  return {
    restrict: 'A',
    scope: {
      stockItem: '=stockItem',
      basketModal: '=basketModal'
    },
    templateUrl: 'templates/products/item.html',
    link: function(scope, element, attrs) {}
  };
});

var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

angular.module('kronoapp.products.services', []).factory('Product', function(_, $q, BaseModel, FIREBASE_URI, IMAGES_URL) {
  var Product;
  Product = (function(superClass) {
    extend(Product, superClass);

    function Product() {
      return Product.__super__.constructor.apply(this, arguments);
    }

    Product.basePath = FIREBASE_URI;

    Product.path = 'v1/products';

    Product.submodels = {
      'profile': {
        'name': {
          'type': String
        },
        'image': {
          'type': String
        }
      }
    };

    Product.prototype.imageURL = function() {
      return IMAGES_URL + this.image;
    };

    Product.prototype.$$updated = function(snap) {
      var changed;
      changed = Product.__super__.$$updated.apply(this, arguments);
      this._id = this.$id;
      this._getWeight();
      return changed;
    };

    Product.prototype._getWeight = function() {
      var re, weight, weight_match;
      re = /([0-9\.]+(?:und|Kg|g|mg|Lb|L|ml|m|cm|mm|Oz))/;
      weight_match = this.name.match(re);
      if ((weight_match != null) && weight_match.length) {
        weight = weight_match[0];
        this.name = this.name.replace(weight, '');
        return this.weight = weight;
      }
    };

    return Product;

  })(BaseModel);
  return Product;
}).factory('Products', function(BaseModelList, Product) {
  var Products;
  Products = (function(superClass) {
    extend(Products, superClass);

    function Products() {
      return Products.__super__.constructor.apply(this, arguments);
    }

    Products.Model = Product;

    return Products;

  })(BaseModelList);
  return Products;
});

angular.module('kronoapp.stores.controllers', []).controller('ProfileCtrl', function($scope, $analytics) {
  $analytics.eventTrack('Page View', {
    'page': 'Profile'
  });
  $scope.showHide = function() {
    return $scope.varShowHide = !$scope.varShowHide;
  };
  return $scope.save = function() {
    $scope.varShowHide = !$scope.varShowHide;
    return $scope.user.$save();
  };
});

angular.module('kronoapp.stores.controllers', []).controller('LobbyCtrl', function(_, $scope, $stateParams, $analytics, $window, $localStorage, storeHelpers, AmountOfTimesOpen, $state, StringManipulation) {
  storeHelpers.extendStoreController($scope, $stateParams, ['profile', 'details', 'categories', 'purchaseInfo']).then((function() {
    var orderCategories;
    $window.fbq('track', "PageView");
    $analytics.eventTrack('Page View', {
      'page': 'Store Lobby',
      'store': $scope.store.name
    });
    $scope.categories = $scope.store.allCategories();
    $scope.orderCategories = $scope.store.allOrderCategories();
    orderCategories = {};
    $scope.orderCategories.$loaded().then(function() {
      return angular.forEach($scope.orderCategories, function(category) {
        return orderCategories[category['$id']] = category['position'];
      });
    });
    $scope.reverse = true;
    $scope.sortCategory = function(categoryRef) {
      var opens;
      if ($scope.store.orderCategories) {
        return orderCategories[categoryRef.$id];
      } else {
        opens = AmountOfTimesOpen.getOpens(categoryRef.$id, $scope.store.$id, 'user-categories-usage');
        opens = StringManipulation.padding(opens, 7);
        return opens + categoryRef.name;
      }
    };
    return $scope.storeCategory = function(category) {
      AmountOfTimesOpen.opened(category.$id, $scope.store.$id, 'user-categories-usage');
      return $state.go('app.store-category', {
        storeId: $scope.store.$id,
        categoryId: category.$id
      });
    };
  }));
  $localStorage['lastStoreId'] = $stateParams.storeId;
  return $rootScope.lastVisitedStore = $localStorage['lastStoreId'];
}).controller('SearchOverlayCtrl', function(_, $scope, $stateParams, $timeout, $state, $analytics, $window, Stores, storeHelpers, $ionicPopup, Feedback, $localStorage, l) {
  var reset, sendFeedback;
  $scope.search = {};
  $scope.search.results = [];
  $scope.search.status = 'no-imput';
  $scope.search.error = null;
  $scope.search.exec = function(q) {
    if (q.length > 2) {
      $window.fbq('track', 'Search');
      $analytics.eventTrack('Search', {
        'store': $scope.store.name,
        'text': q
      });
      $scope.search.status = 'loading';
      $scope.search.results = [];
      return $scope.store.search(q).then(function(stockItems) {
        if (stockItems.length === 0) {
          $scope.search.status = 'empty';
          $analytics.eventTrack('Empty Search', {
            'store': $scope.store.name,
            'text': q
          });
        } else {
          $scope.search.status = 'retreived';
          $scope.closeKeyboard();
        }
        return $scope.search.results = stockItems;
      })["catch"](function(error) {
        $scope.search.error = error;
        return $scope.search.status = 'error';
      })["finally"](function() {
        return $scope.search.loading = false;
      });
    } else {
      $scope.search.status = 'no-imput';
      return $scope.search.results = [];
    }
  };
  $scope.$on('search', function(e, searchText) {
    return $scope.search.exec(searchText);
  });
  $scope.$on('clear-search', function(e) {
    return $scope.search.exec('');
  });
  reset = function() {
    return $scope.feedbackFormSearch = {
      feedback: {
        userId: null,
        text: ''
      },
      error: null
    };
  };
  reset();
  sendFeedback = function() {
    if (!$scope.feedbackFormSearch.error) {
      $scope.feedbackFormSearch.sending = true;
      return Feedback.create($scope.feedbackFormSearch.feedback).$loaded()["finally"](function() {
        reset();
        $ionicPopup.alert({
          title: l('%global.message'),
          template: l('%feedback.sended')
        });
        return $scope.feedbackFormSearch.sending = false;
      });
    }
  };
  return $scope.sendSuggestionSearch = function() {
    var name;
    if ($scope.user) {
      $scope.feedbackFormSearch.feedback.userId = $scope.user._id;
    }
    $analytics.eventTrack('Feedback sent', {
      context: 'products list'
    });
    if ($scope.feedbackFormSearch.feedback.text.length === 0) {
      $scope.feedbackFormSearch.error = l('%stores.suggestion.error');
    } else {
      $scope.feedbackFormSearch.error = null;
    }
    if (!$scope.feedbackFormSearch.feedback.userId) {
      name = $localStorage['user-feedback-email'];
      if (name == null) {
        return $ionicPopup.show({
          title: l('%global.confirm'),
          subTitle: l('%stores.suggestion.user_email'),
          template: '<input type="email" ng-model="feedbackFormSearch.feedback.name">',
          scope: $scope,
          buttons: [
            {
              text: l('%feedback.submit'),
              type: 'button-positive',
              onTap: (function(_this) {
                return function() {
                  name = $scope.feedbackFormSearch.feedback.name;
                  $localStorage['user-feedback-email'] = name;
                  return sendFeedback();
                };
              })(this)
            }
          ]
        });
      } else {
        $scope.feedbackFormSearch.feedback.name = name;
        return sendFeedback();
      }
    } else {
      return sendFeedback();
    }
  };
}).controller('CategoryCtrl', function(_, $scope, $stateParams, $analytics, Device, storeHelpers, AmountOfTimesOpen, $state, StringManipulation) {
  return storeHelpers.extendStoreController($scope, $stateParams, ['profile', 'details', 'categories']).then((function() {
    var orderSubCategories;
    $scope.category = $scope.store.getCategory($stateParams.categoryId);
    $scope.category.$loaded(function() {
      return $analytics.eventTrack('Page View', {
        'page': 'Store Category',
        'store': $scope.store.name,
        'category': $scope.category.name
      });
    });
    $scope.reverse = true;
    $scope.orderSubCategories = $scope.store.allOrderSubCategories($scope.category.$id, $scope.store.$id);
    orderSubCategories = {};
    $scope.orderSubCategories.$loaded().then(function() {
      return angular.forEach($scope.orderSubCategories, function(subCategory) {
        return orderSubCategories[subCategory['$id']] = subCategory['position'];
      });
    });
    $scope.sortSubcategory = function(subcategoryRef) {
      var opens;
      if ($scope.store.orderSubCategories) {
        return orderSubCategories[subcategoryRef.$id];
      } else {
        opens = AmountOfTimesOpen.getOpens(subcategoryRef.$id, $scope.store.$id, 'user-subcategories-usage');
        opens = StringManipulation.padding(opens, 7);
        return opens + subcategoryRef.name;
      }
    };
    return $scope.storeSubcategory = function(subcategory) {
      AmountOfTimesOpen.opened(subcategory.$id, $scope.store.$id, 'user-subcategories-usage');
      return $state.go('app.store-subcategory', {
        storeId: $scope.store.$id,
        subcategoryId: subcategory.$id
      });
    };
  }));
}).controller('SubcategoryCtrl', function(_, $scope, $stateParams, $analytics, storeHelpers, $ionicPopup, Feedback, $localStorage, l) {
  var reset, sendFeedback;
  storeHelpers.extendStoreController($scope, $stateParams, ['profile', 'details', 'subcategories']).then((function() {
    $scope.subcategory = $scope.store.getSubcategory($stateParams.subcategoryId);
    return $scope.subcategory.$loaded(function() {
      return $analytics.eventTrack('Page View', {
        'page': 'Store Subcategory',
        'store': $scope.store.name,
        'subcategory': $scope.subcategory.name
      });
    });
  }));
  $scope.$on('$ionicView.beforeEnter', function() {
    if (!$scope.loading) {
      return $scope.productPickingTutorial.openOnce();
    }
  });
  reset = function() {
    return $scope.feedbackFormProduct = {
      feedback: {
        userId: null,
        text: ''
      },
      error: null
    };
  };
  reset();
  sendFeedback = function() {
    if (!$scope.feedbackFormProduct.error) {
      $scope.feedbackFormProduct.sending = true;
      return Feedback.create($scope.feedbackFormProduct.feedback).$loaded()["finally"](function() {
        reset();
        $ionicPopup.alert({
          title: l('%global.message'),
          template: l('%feedback.sended')
        });
        return $scope.feedbackFormProduct.sending = false;
      });
    }
  };
  $scope.sendSuggestionProduct = function() {
    var name;
    if ($scope.user) {
      $scope.feedbackFormProduct.feedback.userId = $scope.user._id;
    }
    $scope.feedbackFormProduct.feedback.storeId = $scope.store.$id;
    $analytics.eventTrack('Feedback sent', {
      context: 'products list'
    });
    if ($scope.feedbackFormProduct.feedback.text.length === 0) {
      $scope.feedbackFormProduct.error = l('%stores.suggestion.error');
    } else {
      $scope.feedbackFormProduct.error = null;
    }
    if (!$scope.feedbackFormProduct.feedback.userId) {
      name = $localStorage['user-feedback-email'];
      if (name == null) {
        return $ionicPopup.show({
          title: l('%global.confirm'),
          subTitle: l('%stores.suggestion.user_email'),
          template: '<input type="email" ng-model="feedbackFormProduct.feedback.name">',
          scope: $scope,
          buttons: [
            {
              text: l('%feedback.submit'),
              type: 'button-positive',
              onTap: (function(_this) {
                return function() {
                  name = $scope.feedbackFormProduct.feedback.name;
                  $localStorage['user-feedback-email'] = name;
                  return sendFeedback();
                };
              })(this)
            }
          ]
        });
      } else {
        $scope.feedbackFormProduct.feedback.name = name;
        return sendFeedback();
      }
    } else {
      return sendFeedback();
    }
  };
  return ($scope.doubleTapMessage = function() {
    var counter;
    $scope.existDoubleTapMessage = true;
    counter = $localStorage['doubleTapMessage'];
    if (!(counter != null)) {
      return $localStorage['doubleTapMessage'] = 1;
    } else {
      if ($localStorage['doubleTapMessage'] <= 19) {
        return $localStorage['doubleTapMessage'] += 1;
      } else {
        return $scope.existDoubleTapMessage = false;
      }
    }
  })();
}).controller('OrderCheckoutCtrl', function(l, _, $scope, $localStorage, $state, $stateParams, $analytics, $window, $ionicPopup, $timeout, storeHelpers, Orders) {
  return storeHelpers.extendStoreController($scope, $stateParams, ['profile', 'details', 'purchaseInfo']).then((function() {
    var getDeliveryOptionPath;
    $window.fbq('track', 'InitiateCheckout');
    $analytics.eventTrack('Page View', {
      'page': 'Checkout View',
      'store': $scope.store.name
    });
    $scope.$storage = $localStorage;
    getDeliveryOptionPath = function(optionKey) {
      var optionName;
      if (optionKey === Orders.deliveryOptions.Pickup) {
        optionName = 'pickUp';
      } else if (optionKey === Orders.deliveryOptions.Domicile) {
        optionName = 'domicile';
      }
      return optionName;
    };
    $scope.hasDeliveryOption = function(deliveryOptionKey) {
      var deliveryOption, deliveryOptionName, paymentMethods;
      deliveryOptionName = getDeliveryOptionPath(deliveryOptionKey);
      deliveryOption = $scope.store.orderOptions[deliveryOptionName] || {};
      paymentMethods = deliveryOption.paymentMethods || {};
      return paymentMethods.CARD || paymentMethods.CASH;
    };
    $scope.hasPaymentOption = function(paymentOptionKey) {
      var deliveryOption, deliveryOptionKey, deliveryOptionName, paymentMethods;
      deliveryOptionKey = $scope.orderDesc.deliveryType;
      deliveryOptionName = getDeliveryOptionPath(deliveryOptionKey);
      deliveryOption = $scope.store.orderOptions[deliveryOptionName] || {};
      paymentMethods = deliveryOption.paymentMethods || {};
      return paymentMethods[paymentOptionKey];
    };
    $scope.resetPaymentOptions = function() {
      return delete $scope.orderDesc.paymentMethod;
    };
    $scope.$watch('orderDesc.deliveryType', function() {
      $scope.resetPaymentOptions();
      return $scope.$watch('orderDesc.paymentMethod', function() {
        return $window.fbq('track', 'AddPaymentInfo');
      });
    });
    $scope.deliveryOptions = {
      Pickup: Orders.deliveryOptions.Pickup,
      Domicile: Orders.deliveryOptions.Domicile
    };
    $scope.paymentOptions = {
      Card: Orders.paymentOptions.Card,
      Cash: Orders.paymentOptions.Cash
    };
    $scope.total = function() {
      var deliveryZone;
      deliveryZone = $scope.orderDesc.deliveryZone;
      if (deliveryZone != null) {
        return $scope.basketModal.total() + deliveryZone.cost;
      } else {
        return $scope.basketModal.total();
      }
    };
    return $scope.validation = function() {
      var errorKey, errorStr, isValid, ref;
      if (!$scope.orderDesc.deliveryType) {
        $ionicPopup.alert({
          title: l('%global.alert'),
          template: l('%delivery_domicile.errors.delivery_type.empty')
        });
        return;
      }
      if (!$scope.orderDesc.paymentMethod) {
        $ionicPopup.alert({
          title: l('%global.alert'),
          template: l('%delivery_payment.errors.payment_method.empty')
        });
        return;
      }
      isValid = true;
      $scope.errors = {
        addressLine1: null,
        addressLine2: null,
        deliveryZone: null
      };
      if ($scope.orderDesc.deliveryType !== Orders.deliveryOptions.Domicile) {
        delete $scope.orderDesc.addressLine1;
        delete $scope.orderDesc.addressLine2;
        delete $scope.orderDesc.deliveryZone;
      } else {
        $scope.orderDesc.addressLine1 = $scope.$storage.orderDesc_addressLine1;
        $scope.orderDesc.addressLine2 = $scope.$storage.orderDesc_addressLine2;
        if ($scope.orderDesc.addressLine1 == null) {
          $scope.errors.addressLine1 = '%delivery_domicile.errors.address_line1.empty';
          isValid = false;
        } else if ($scope.orderDesc.addressLine1.length < 4) {
          $scope.errors.addressLine1 = '%delivery_domicile.errors.address_line1.short';
          isValid = false;
        }
        if ($scope.orderDesc.addressLine2 == null) {
          $scope.errors.addressLine2 = '%delivery_domicile.errors.address_line2.empty';
          isValid = false;
        } else if ($scope.orderDesc.addressLine2.length < 4) {
          $scope.errors.addressLine2 = '%delivery_domicile.errors.address_line2.short';
          isValid = false;
        }
        if ($scope.orderDesc.deliveryZone == null) {
          $scope.errors.deliveryZone = '%delivery_domicile.errors.delivery_zone.empty';
          isValid = false;
        }
      }
      if (isValid) {
        return $state.go('app.order-summary', {
          storeId: $scope.store._id
        });
      } else {
        ref = $scope.errors;
        for (errorKey in ref) {
          errorStr = ref[errorKey];
          $analytics.eventTrack('User error in domicile form', {
            'error': errorStr,
            'errorKey': errorKey
          });
        }
        return $ionicPopup.alert({
          title: l('%global.alert'),
          template: l('%delivery_domicile.alert.form_error')
        });
      }
    };
  }));
}).controller('OrderSummaryCtrl', function(_, $rootScope, $scope, $state, $stateParams, $ionicHistory, $timeout, $analytics, $window, Branch, Orders, Device, storeHelpers, SINGLE_STORE_ID) {
  $scope.newPhone = $scope.user.phone;
  $scope.varShowHide = false;
  $scope.funShowHide = function() {
    return $scope.varShowHide = !$scope.varShowHide;
  };
  $scope.saveNewPhone = function() {
    $scope.varShowHide = !$scope.varShowHide;
    return $scope.user.$save();
  };
  $scope.storeId = SINGLE_STORE_ID;
  $scope.goLobby = function(x) {
    $ionicHistory.nextViewOptions({
      disableBack: true
    });
    return $state.go('app.store-lobby', {
      storeId: x
    });
  };
  if (SINGLE_STORE_ID !== null) {
    $scope.singleStore = true;
  } else {
    $scope.singleStore = false;
  }
  storeHelpers.extendStoreController($scope, $stateParams, ['profile']).then(function() {
    return $analytics.eventTrack('Page View', {
      'page': 'Order Summary',
      'store': $scope.store.name
    });
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    return $timeout((function() {
      $scope.sendingOrder = false;
      return delete $scope.order;
    }), 500);
  });
  $scope.total = function() {
    var orderDesc, total;
    orderDesc = $scope.orderDesc;
    total = orderDesc.$total;
    if (orderDesc.deliveryZone) {
      total += orderDesc.deliveryZone.cost;
    }
    return total;
  };
  $scope.placeOrder = function() {
    var order, orderEvent;
    $scope.sendingOrder = true;
    orderEvent = {
      'store': $scope.store.name,
      'total': $scope.total(),
      'distinctItems': $scope.orderDesc.items.length,
      'paymentMethod': $scope.orderDesc.paymentMethod,
      'deliveryZone': ($scope.orderDesc.deliveryZone || {}).name,
      'deliveryType': $scope.orderDesc.deliveryType
    };
    $window.fbq('track', 'Purchase', {
      value: $scope.total(),
      currency: 'COT'
    });
    $analytics.eventTrack('Order Placed', orderEvent);
    Branch.track('Order Placed', orderEvent);
    if ($scope.orderDesc.hasOwnProperty("deliveryZone")) {
      if ($scope.orderDesc.deliveryZone.hasOwnProperty("$$hashKey")) {
        delete $scope.orderDesc.deliveryZone.$$hashKey;
      }
    }
    $scope.orderDesc.userId = $scope.user.$id;
    order = Orders.placeOrder(_($scope.orderDesc).omit('$total'));
    return order.$loaded().then(function() {
      mixpanel.people.track_charge($scope.total(), {
        'store': $scope.store.name
      });
      Device.subscribeToChannels(['shopper', "shopper-" + $scope.store.$id]);
      $scope.basketModal.resetBasket();
      $scope.order = order;
      return $scope.sendingOrder = false;
    })["catch"](function(reason) {
      console.error(reason);
      alert(l('%order_summary.errors.not_sent'));
      return $scope.sendingOrder = false;
    });
  };
  return $scope.goHome = function() {
    $ionicHistory.nextViewOptions({
      'disableBack': true
    });
    return $state.go('app.home');
  };
});

var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

angular.module('kronoapp.stores.services', ['underscore', 'firebase', 'utils.services', 'kronoapp.config', 'denormalizedORM', 'kronoapp.products.services']).factory('Store', function(_, $q, $http, BaseModel, Geometry, StoreCategories, StoreOrderCategories, Category, StoreSubcategories, StoreOrderSubCategories, Subcategory, StockItem, BASE_URL, FIREBASE_URI, IMAGES_URL) {
  var Store;
  Store = (function(superClass) {
    extend(Store, superClass);

    function Store() {
      return Store.__super__.constructor.apply(this, arguments);
    }

    Store.basePath = FIREBASE_URI;

    Store.path = 'v1/stores';

    Store.submodels = {
      'profile': {
        'name': {
          'type': String,
          'required': true
        },
        'logo': {
          'type': String,
          'required': true
        },
        'chainId': {
          'type': String
        },
        'position': {
          'type': Number
        },
        'geolocation': {
          'type': Object
        },
        'isActive': {
          'type': Boolean
        },
        'orderCategories': {
          'type': Boolean
        },
        'orderSubCategories': {
          'type': Boolean
        }
      },
      'details': {
        'backgroundImage': {
          'type': String
        },
        'description': {
          'type': String
        },
        'sector': {
          'type': String,
          'required': true
        }
      },
      'purchaseInfo': {
        'minimumPurchase': {
          'type': Number
        },
        'orderOptions': {
          'type': Object
        },
        'zones': {
          'type': Array
        }
      }
    };

    Store.prototype.logoURL = function() {
      return IMAGES_URL + this.logo;
    };

    Store.prototype.backgroundURL = function() {
      return IMAGES_URL + this.backgroundImage;
    };

    Store.prototype.mapImageURL = function() {
      return IMAGES_URL + ((this.orderOptions || {}).pickUp || {}).mapImage;
    };

    Store.prototype.fullName = function() {
      if (this.chainId != null) {
        return this.chainId + " - " + this.name;
      } else {
        return this.name;
      }
    };

    Store.prototype.calculateDistance = function(geolocation) {
      if (this.geolocation != null) {
        this.distance = Geometry.haversineDistance(this.geolocation.lat, this.geolocation.lon, geolocation.lat, geolocation.lon);
      } else {
        this.distance = Number.MAX_VALUE;
      }
      return this.distance;
    };

    Store.prototype.categoriesRef = function() {
      return this.constructor.ref().child('categories').child(this.$id);
    };

    Store.prototype.orderCategoriesRef = function() {
      return this.constructor.ref().child('orderCategories').child(this.$id);
    };

    Store.prototype.orderSubCategoriesRef = function(subcategoryId) {
      return this.constructor.ref().child('orderSubCategories').child(this.$id).child(subcategoryId);
    };

    Store.prototype.subcategoriesRef = function() {
      return this.constructor.ref().child('subcategories').child(this.$id);
    };

    Store.prototype.allCategories = function() {
      return new StoreCategories(this);
    };

    Store.prototype.allOrderCategories = function() {
      return new StoreOrderCategories(this);
    };

    Store.prototype.allOrderSubCategories = function(subcategoryId) {
      return new StoreOrderSubCategories(subcategoryId, this);
    };

    Store.prototype.getCategory = function(categoryId) {
      return Category.fromStore(categoryId, this);
    };

    Store.prototype.getSubcategory = function(subcategoryId) {
      return Subcategory.fromStore(subcategoryId, this);
    };

    Store.prototype.$$updated = function(snap) {
      var changed;
      changed = Store.__super__.$$updated.apply(this, arguments);
      this._id = this.$id;
      this._calculateChainId();
      return changed;
    };

    Store.prototype.search = function(q) {
      return $http.get(BASE_URL + "stores/" + this.$id + "/search-stock/", {
        'params': {
          'q': q,
          'slim': true
        }
      }).then(function(response) {
        var id, list;
        console.log("Search resp: ", response);
        list = (function() {
          var i, len, ref1, results;
          ref1 = response.data;
          results = [];
          for (i = 0, len = ref1.length; i < len; i++) {
            id = ref1[i];
            results.push(StockItem.get(id));
          }
          return results;
        })();
        return list;
      });
    };

    Store.prototype._calculateChainId = function() {
      var chainAndStore;
      chainAndStore = this.name.split(' - ');
      if (chainAndStore.length > 1) {
        this.chainId = chainAndStore[0].trim();
        return this.name = chainAndStore[1].trim();
      } else {
        return this.chainId = '';
      }
    };

    return Store;

  })(BaseModel);
  return Store;
}).factory('Stores', function(BaseModelList, Store) {
  var Stores;
  Stores = (function(superClass) {
    extend(Stores, superClass);

    function Stores() {
      return Stores.__super__.constructor.apply(this, arguments);
    }

    Stores.Model = Store;

    return Stores;

  })(BaseModelList);
  return Stores;
}).factory('Category', function(_, $q, BaseModel, StoreSubcategories, FIREBASE_URI, IMAGES_URL) {
  var Category;
  Category = (function(superClass) {
    extend(Category, superClass);

    function Category() {
      return Category.__super__.constructor.apply(this, arguments);
    }

    Category.basePath = FIREBASE_URI;

    Category.path = 'v1/categories';

    Category.submodels = {
      'profile': {
        'name': {
          'type': String
        },
        'image': {
          'type': String
        },
        'position': {
          'type': Number
        }
      }
    };

    Category.prototype.imageURL = function() {
      return IMAGES_URL + this.image;
    };

    Category.fromStore = function(categoryId, store) {
      var result;
      result = this.get(categoryId);
      result.$loaded(function() {
        return result.subcategories = new StoreSubcategories(categoryId, store);
      });
      return result;
    };

    Category.prototype.$$updated = function(snap) {
      var changed;
      changed = Category.__super__.$$updated.apply(this, arguments);
      this._id = this.$id;
      return changed;
    };

    return Category;

  })(BaseModel);
  return Category;
}).factory('StoreOrderCategories', function(_, $q, BaseModelList, $firebaseArray) {
  var StoreOrderCategories;
  StoreOrderCategories = (function() {
    function StoreOrderCategories(store) {
      var result;
      result = $firebaseArray.call(this, store.orderCategoriesRef());
      return result;
    }

    return StoreOrderCategories;

  })();
  return $firebaseArray.$extend(StoreOrderCategories);
}).factory('StoreOrderSubCategories', function(_, $q, BaseModelList, $firebaseArray) {
  var StoreOrderSubCategories;
  StoreOrderSubCategories = (function() {
    function StoreOrderSubCategories(subcategoryId, store) {
      var result;
      result = $firebaseArray.call(this, store.orderSubCategoriesRef(subcategoryId));
      return result;
    }

    return StoreOrderSubCategories;

  })();
  return $firebaseArray.$extend(StoreOrderSubCategories);
}).factory('StoreCategories', function(_, $q, BaseModelList, Category, $firebaseArray) {
  var StoreCategories;
  StoreCategories = (function() {
    function StoreCategories(store) {
      var result;
      result = $firebaseArray.call(this, store.categoriesRef());
      return result;
    }

    StoreCategories.prototype.$$added = function(snap) {
      var instance;
      instance = Category.get(snap.key());
      return instance.$loaded();
    };

    return StoreCategories;

  })();
  return $firebaseArray.$extend(StoreCategories);
}).factory('Subcategory', function(_, $q, BaseModel, FIREBASE_URI, IMAGES_URL, StockItems) {
  var Subcategory;
  Subcategory = (function(superClass) {
    extend(Subcategory, superClass);

    function Subcategory() {
      return Subcategory.__super__.constructor.apply(this, arguments);
    }

    Subcategory.basePath = FIREBASE_URI;

    Subcategory.path = 'v1/subcategories';

    Subcategory.submodels = {
      'profile': {
        'name': {
          'type': String
        },
        'image': {
          'type': String
        },
        'position': {
          'type': Number
        }
      }
    };

    Subcategory.prototype.imageURL = function() {
      return IMAGES_URL + this.image;
    };

    Subcategory.fromStore = function(subcategoryId, store) {
      var subcategory;
      subcategory = this.get(subcategoryId);
      subcategory.$loaded(function() {
        return subcategory.stockItems = new StockItems(store, subcategoryId);
      });
      return subcategory;
    };

    Subcategory.prototype.stockItemsRef = function(store) {
      return this.constructor.ref().child('subcategories').child(this.$id);
    };

    Subcategory.prototype.$$updated = function(snap) {
      var changed;
      changed = Subcategory.__super__.$$updated.apply(this, arguments);
      this._id = this.$id;
      return changed;
    };

    return Subcategory;

  })(BaseModel);
  return Subcategory;
}).factory('StoreSubcategories', function(_, $q, BaseModelList, Subcategory, $firebaseArray) {
  var StoreCategories;
  StoreCategories = (function() {
    function StoreCategories(categoryId, store) {
      var ref, result;
      ref = store.categoriesRef().child(categoryId);
      result = $firebaseArray.call(this, ref);
      return result;
    }

    StoreCategories.prototype.$$added = function(snap) {
      var instance;
      instance = Subcategory.get(snap.key());
      return instance.$loaded();
    };

    return StoreCategories;

  })();
  return $firebaseArray.$extend(StoreCategories);
}).factory('StockItem', function(_, $q, BaseModel, FIREBASE_URI, IMAGES_URL, Product) {
  var StockItem;
  StockItem = (function(superClass) {
    extend(StockItem, superClass);

    function StockItem() {
      return StockItem.__super__.constructor.apply(this, arguments);
    }

    StockItem.basePath = FIREBASE_URI;

    StockItem.path = 'v1/stockItems';

    StockItem.submodels = {
      'profile': {
        'productId': {
          'type': String
        },
        'discount': {
          'type': Number
        },
        'price': {
          'type': Number
        }
      }
    };

    StockItem.prototype.imageURL = function() {
      return IMAGES_URL + this.image;
    };

    StockItem.prototype.$$updated = function(snap) {
      var changed;
      changed = StockItem.__super__.$$updated.apply(this, arguments);
      this._id = this.$id;
      if (!this.$product) {
        this.$product = Product.get(this.productId);
        this.$product.$stockItem = this;
      }
      return changed;
    };

    return StockItem;

  })(BaseModel);
  return StockItem;
}).factory('StockItems', function(_, $q, BaseModelList, StockItem, $firebaseArray) {
  var StockItems;
  StockItems = (function() {
    function StockItems(store, subcategoryId) {
      var ref, result;
      ref = store.subcategoriesRef().child(subcategoryId).child('stockItemsPositions');
      result = $firebaseArray.call(this, ref);
      return result;
    }

    StockItems.prototype.$$added = function(snap) {
      var instance;
      instance = StockItem.get(snap.key());
      instance.$position = snap.val();
      return instance.$loaded();
    };

    return StockItems;

  })();
  return $firebaseArray.$extend(StockItems);
}).factory('storeHelpers', function($q, $state, $timeout, $ionicNavBarDelegate, $analytics, $ionicScrollDelegate, $ionicPopup, Store) {
  return {
    populateStore: function(store, basket, basketModal) {
      return store.$loaded().then(function() {
        return basket.$loaded().then(function() {
          basketModal.setStore(store);
          return store;
        });
      }, function(error) {
        return $q.reject(error);
      });
    },
    extendStoreController: function(scope, stateParams, projection) {
      var q;
      q = $q.defer();
      scope.storeState = {
        loading: null,
        error: false
      };
      scope.searchHandler = {
        open: false,
        text: ''
      };
      scope.store = Store.get(stateParams.storeId, projection);
      scope.$on('$ionicView.beforeEnter', (function(_this) {
        return function() {
          if (!scope.storeState.loading) {
            scope.storeState.loading = true;
            return _this.populateStore(scope.store, scope.basket, scope.basketModal).then(function() {
              scope.storeState.loading = false;
              scope.storeState.error = false;
              return q.resolve();
            })["catch"](function(error) {
              scope.storeState.error = error;
              return q.reject(error);
            })["finally"](function() {
              return scope.storeState.loading = false;
            });
          }
        };
      })(this));
      scope.$on('$ionicView.beforeLeave', (function(_this) {
        return function() {
          return scope.close_search();
        };
      })(this));
      scope.make_search = function(searchText) {
        $ionicScrollDelegate.scrollTop();
        return scope.$broadcast('search', searchText);
      };
      scope.open_search = function() {
        $analytics.eventTrack('Open search', {
          'store': scope.store.name
        });
        $ionicNavBarDelegate.showBackButton(false);
        $ionicScrollDelegate.scrollTop();
        return scope.searchHandler.open = true;
      };
      scope.close_search = function() {
        $timeout((function() {
          return $ionicNavBarDelegate.showBackButton(true);
        }), 500);
        scope.searchHandler.text = '';
        scope.searchHandler.open = false;
        return scope.$broadcast('clear-search');
      };
      scope.productItemDetail = function(productItem) {
        scope.itemDetail = productItem;
        return scope.itemDetailPopup = $ionicPopup.show({
          templateUrl: 'templates/products/itemDetail.html',
          scope: scope,
          cssClass: 'popupHeaderOff'
        });
      };
      return q.promise;
    }
  };
});

angular.module('kronoapp.tutorials', ['ionic', 'underscore', 'ngStorage', 'kronoapp.analytics', 'kronoapp.auth', 'kronoapp.tutorials.services']).run(function($ionicPlatform, $window) {}).config(function() {});

var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

angular.module('kronoapp.tutorials.services', []).factory('BaseTutorial', function($ionicModal, $rootScope, $localStorage) {
  var BaseTutorial;
  BaseTutorial = (function() {
    BaseTutorial.version = null;

    BaseTutorial.prototype._storageVersionKey = null;

    BaseTutorial.prototype._template = null;

    BaseTutorial.prototype._scope = null;

    BaseTutorial.prototype._promise = null;

    function BaseTutorial(backdropClickToClose) {
      if (backdropClickToClose == null) {
        backdropClickToClose = false;
      }
      if (this.constructor.version == null) {
        throw new Error("version not set");
      }
      if (this._storageVersionKey == null) {
        throw new Error("_storageVersionKey not set");
      }
      if (this._template == null) {
        throw new Error("_template not set");
      }
      this._scope = $rootScope.$new();
      this._promise = $ionicModal.fromTemplateUrl(this._template, {
        scope: this._scope,
        animation: 'slide-in-up',
        backdropClickToClose: backdropClickToClose
      }).then((function(_this) {
        return function(modal) {
          _this._scope.modal = modal;
          return modal;
        };
      })(this));
      this._scope.open = (function(_this) {
        return function() {
          return _this._scope.modal.show();
        };
      })(this);
      this._scope.close = (function(_this) {
        return function() {
          return _this._scope.modal.hide();
        };
      })(this);
      this._scope.$on('$destroy', (function(_this) {
        return function() {
          return _this._scope.modal.remove();
        };
      })(this));
      return;
    }

    BaseTutorial.prototype.openOnce = function() {
      if ($localStorage["tutorials:" + this._storageVersionKey] !== this.constructor.version) {
        $localStorage["tutorials:" + this._storageVersionKey] = this.constructor.version;
        this.open();
      }
      return this;
    };

    BaseTutorial.prototype.open = function() {
      this._promise.then(((function(_this) {
        return function() {
          return _this._scope.open();
        };
      })(this)));
      return this;
    };

    BaseTutorial.prototype.close = function(redirect) {
      if (redirect == null) {
        redirect = false;
      }
      this._promise.then(((function(_this) {
        return function() {
          return _this._scope.close(redirect);
        };
      })(this)));
      return this;
    };

    BaseTutorial.prototype.remove = function() {
      return this._scope.modal.remove();
    };

    BaseTutorial.prototype.on = function(ev, cb) {
      return this._scope.$on(ev, cb);
    };

    return BaseTutorial;

  })();
  return BaseTutorial;
}).factory('ProductPickingTutorial', function(BaseTutorial) {
  var ProductPickingTutorial;
  ProductPickingTutorial = (function(superClass) {
    extend(ProductPickingTutorial, superClass);

    ProductPickingTutorial.version = 2;

    ProductPickingTutorial.prototype._storageVersionKey = 'productPicking';

    ProductPickingTutorial.prototype._template = 'templates/tutorials/product-picking.html';

    function ProductPickingTutorial() {
      ProductPickingTutorial.__super__.constructor.call(this);
    }

    return ProductPickingTutorial;

  })(BaseTutorial);
  return ProductPickingTutorial;
}).factory('WelcomeTutorial', function(BaseTutorial, $ionicSlideBoxDelegate, $timeout, Device) {
  var WelcomeTutorial;
  WelcomeTutorial = (function(superClass) {
    extend(WelcomeTutorial, superClass);

    WelcomeTutorial.version = 0;

    WelcomeTutorial.prototype._storageVersionKey = 'welcomeTutorial';

    WelcomeTutorial.prototype._template = 'templates/tutorials/welcome.html';

    function WelcomeTutorial() {
      WelcomeTutorial.__super__.constructor.call(this, true);
      this._promise.then((function(_this) {
        return function() {
          var slideBox;
          slideBox = $ionicSlideBoxDelegate.$getByHandle('WelcomeTutorialSlideBox');
          return $timeout((function() {
            return slideBox.enableSlide(false);
          }), 1000);
        };
      })(this));
      this._scope.deviceType = Device.deviceType();
      this._scope.nextPage = (function(_this) {
        return function() {
          return _this._scope.pageNumber++;
        };
      })(this);
      this._scope.prevPage = (function(_this) {
        return function() {
          return _this._scope.pageNumber--;
        };
      })(this);
      this._scope.requestPushPermissions = (function(_this) {
        return function() {
          Device.initializeNotifications(['client']);
          return _this.close();
        };
      })(this);
      this._scope.$on('modal.shown', (function(_this) {
        return function() {
          _this._scope.loaded = false;
          _this._scope.pageNumber = 0;
          _this._scope.requireNotifications = false;
          if (_this._scope.deviceType === 'ios') {
            return Device.areNotificationsEnabled().then(function() {
              return _this._scope.requireNotifications = false;
            })["catch"](function() {
              return _this._scope.requireNotifications = true;
            })["finally"](function() {
              return _this._scope.loaded = true;
            });
          } else {
            return _this._scope.loaded = true;
          }
        };
      })(this));
      this._scope.pageOneAccepted = (function(_this) {
        return function() {
          if (_this._scope.requireNotifications) {
            return _this._scope.nextPage();
          } else {
            return _this.close();
          }
        };
      })(this);
      return;
    }

    return WelcomeTutorial;

  })(BaseTutorial);
  return WelcomeTutorial;
});

angular.module('kronoapp.analytics.branch-service', []).factory('Branch', function($window, $q, $ionicPlatform) {
  var genericWrapper;
  $window.DeepLinkHandler = function(data) {
    return console.log('Branch received link data:' + JSON.stringify(data, null, 4));
  };
  genericWrapper = function(cb) {
    return $q(function(resolve, reject) {
      return $ionicPlatform.ready(function() {
        var wBranch;
        if ($window.Branch != null) {
          wBranch = $window.Branch;
          return cb(wBranch, resolve, reject);
        } else {
          return reject('"branch" not found');
        }
      });
    });
  };
  return {
    setDebug: function(doDebug) {
      return genericWrapper(function(wBranch, resolve, reject) {
        if (wBranch.setDebug != null) {
          wBranch.setDebug(doDebug);
        }
        return resolve();
      });
    },
    initSession: function(options) {
      return genericWrapper(function(wBranch, resolve, reject) {
        return wBranch.initSession(options).then(resolve)["catch"](reject);
      });
    },
    setIdentity: function(identity) {
      return genericWrapper(function(wBranch, resolve, reject) {
        return wBranch.setIdentity(identity).then(resolve)["catch"](reject);
      });
    },
    track: function(event, metadata) {
      return genericWrapper(function(wBranch, resolve, reject) {
        return wBranch.userCompletedAction(event, metadata).then(resolve)["catch"](reject);
      });
    },
    logout: function() {
      return genericWrapper(function(wBranch, resolve, reject) {
        return wBranch.logout(function(err) {
          if (err != null) {
            return reject(err);
          }
          return resolve();
        });
      });
    },
    close: function() {
      return $q.when(true);
    }
  };
});

angular.module('kronoapp.analytics', ['ionic', 'ngStorage', 'angulartics', 'angulartics.mixpanel', 'angulartics.google.analytics.cordova', 'kronoapp.analytics.branch-service', 'kronoapp.analytics.services']).run(function($ionicPlatform, $analytics, $window, SessionTracking, Branch, MIXPANEL_TOKEN, GOOGLE_ANALYTICS_KEY, CRITTERCISM_IOS_KEY, CRITTERCISM_ANDROID_KEY, DEBUG, APP_NAME) {
  $window.mixpanel.init(MIXPANEL_TOKEN);
  $window.mixpanel.register({
    "Application Brand": APP_NAME
  });
  Branch.setDebug(DEBUG);
  Branch.initSession();
  return $ionicPlatform.ready(function() {
    if ($window.analytics != null) {
      $window.analytics.startTrackerWithId(GOOGLE_ANALYTICS_KEY);
      if (DEBUG) {
        $window.analytics.debugMode();
      }
    }
    if ($window.Crittercism != null) {
      $window.Crittercism.init({
        'iosAppID': CRITTERCISM_IOS_KEY,
        'androidAppID': CRITTERCISM_ANDROID_KEY
      });
    }
    $ionicPlatform.on('resume', function() {
      $analytics.eventTrack('User resumed app', {});
      SessionTracking.beginSession();
      return Branch.initSession();
    });
    $ionicPlatform.on('pause', function() {
      $analytics.eventTrack('User paused app', {});
      return SessionTracking.finishSession();
    });
    return SessionTracking.beginSession();
  });
}).config(function($analyticsProvider) {
  return $analyticsProvider.virtualPageviews(false);
});

var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

angular.module('kronoapp.analytics.services', ['kronoapp.analytics.branch-service']).factory('PeopleAnalytics', function($window, $timeout, Branch, ANALYTICS_IGNORED_USERS) {
  return {
    'register': function(user) {
      var ref;
      if (ref = user.$id, indexOf.call(ANALYTICS_IGNORED_USERS, ref) >= 0) {
        $window.mixpanel.register({
          "$ignore": true
        });
      }
      if (window.analytics != null) {
        window.analytics.setUserId(user.$id);
      }
      if (user.document) {
        $window.mixpanel.identify(user.$id);
      }
      $window.mixpanel.people.set({
        '$name': user.name,
        '$email': user.email,
        '$phone': user.phone,
        '$last_login': new Date()
      });
      if ($window.Crittercism != null) {
        $window.Crittercism.setUsername(user.name);
        return $window.Crittercism.setValueForKey('id', user.$id);
      }
    },
    'anonymousRegister': function(user) {
      return $timeout((function() {
        var id, name;
        id = $window.mixpanel.get_distinct_id();
        name = "Anonymous " + id;
        if ($window.Crittercism) {
          $window.Crittercism.setUsername(name);
          return $window.Crittercism.setValueForKey('id', id);
        }
      }), 300);
    },
    'logout': function() {
      Branch.logout().then(function() {
        return console.log('User loged out from branch.io');
      })["catch"](function(error) {
        return console.error('Error loging out user for branch.io', error);
      });
      if (window.analytics != null) {
        return window.analytics.setUserId(null);
      }
    }
  };
}).factory('SessionTracking', function(_, $analytics, $localStorage, $log) {
  var beginTime, pauseTime, sessionDeviceId, sessionId;
  sessionDeviceId = $localStorage['sessionDeviceId'];
  if (sessionDeviceId == null) {
    sessionDeviceId = (ionic.Platform.platform()) + ":" + (Date.now().toString(36));
    $localStorage['sessionDeviceId'] = sessionDeviceId;
  }
  sessionId = null;
  pauseTime = 0;
  beginTime = 0;
  return {
    'beginSession': function() {
      var now;
      now = Date.now();
      $log.log("Begin session " + now);
      if ((sessionId == null) || (now - pauseTime) > 30 * 1000) {
        sessionId = now.toString(36);
        beginTime = now;
        $log.log("new Session " + sessionId);
      }
      return pauseTime = 0;
    },
    'finishSession': function() {
      pauseTime = Date.now();
      $analytics.eventTrack("Session ended", {
        "id": sessionDeviceId + "-" + sessionId,
        "sessionLength": ((pauseTime - beginTime) / 1000) | 0
      });
      return $log.log("Finishing session " + sessionId);
    }
  };
});

//# sourceMappingURL=application.js.map
